// CHOPPER.CPP
// Methods for general parsing class, Chopper.

#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <mem.h>
#include <alloc.h>
#include <ctype.h>
#include <fcntl.h>

// comment out next line when linking Chopper class to other main program.
//#define TEST       // keep this in when in test mode (compiles main)

#include "message.h"
#include "chopper.h"
#ifdef TEST
#include "messinit.inc"  // initialize static members of message only once
#endif

// Some prototypes:  (Others may be in something like "proto.h")
char *gstrcpy(char *target, char *source);
short max(int a, int b) {return a>b?a:b;}
short min(int a, int b);
void tap(void);

#ifdef TEST
Chopper ch;  // global Chopper object.  Initialized before program starts.
// test program, for checking Chopper functions:
void main(int argc, char **argv) {
FILE *in;
char s[80];
short type,count=0,c;

if((in=fopen("test.chp","rt"))==NULL) {
	printf("Unable to open test.chp.\n");
	exit(1);
	}

// OK, so this works, try above declaring Chopper global and merely
//   SetSource here.
//Chopper ch(in);  // declare Chopper object.
ch.SetSource(in);

while((type=ch.chop(s))!='e') {
	printf("type is %c.   Field is %s\n",type,s);
	if(! ((count+1)%22) )
		c=getch();
	count++;
	}
fclose(in);
}
#endif
//========================================================================
// default constructor, no input source set
Chopper::Chopper() {
//cout << "Constructing Chopper -> Default constructor.\n";
feedchar = '\n';
feedbuf = 0;
feedbufflag = 0;
ichopbuf=0;
strcpy(chopbuf,"");
initcommandbuf(); // defined inline.
console='y';
insert='y';
saving='n';
save_flag = 'n';
save_data_flag = 'n';
strcpy(SaveDataCommand,"update");
annsaving='n';
catching='n';
addprint=FALSE;
FileOrString=' ';
MsgObject = new GMessage;
// Added for Databanking in IdLift:
JustFound = 0;
npy = 1;
}
//========================================================================
// Constructor that sets input to a certain file stream.
// A typical example of some of this code was in the G function startup().
Chopper::Chopper(FILE* iin) {

//cout << "Constructing Chopper -> With FILE* argument.\n";
ChopSource = iin;
FileOrString='f';
feedchar = '\n';
feedbuf = 0;
feedbufflag=0;
ichopbuf=0;
strcpy(chopbuf,"");
initcommandbuf(); // defined inline.
console=(iin==stdin)?'y':'n';
insert='y';
saving='n';
save_flag = 'n';
annsaving='n';
catching='n';
addprint=FALSE;
MsgObject = new GMessage;
}
//========================================================================
short Chopper::SetSource(FILE *iin) {
ChopSource=iin;
console=(iin==stdin)?'y':'n';
FileOrString='f';
feedchar='\n';
feedbuf=0;
feedbufflag = 0;
//initcommandbuf();  // This wipes out command buffer.
return 0;
}
//========================================================================
// This trick is used to set Chopper to be reading from a string.

short Chopper::SetSource(char *buf) { 
FileOrString='s';
pinbuf = buf;
feedchar = 'a';  // Also indicates file or string.
feedbuf = 0;
feedbufflag = 0;
return 0;
}
//========================================================================
// destructor
Chopper::~Chopper() {
//cout << "Destructing Chopper.\n";
if(MsgObject)
	delete MsgObject;
}
//========================================================================
// getopt now a method of Chopper
const short MAXOPT=200;
short Chopper::getopt(char *line, short maxchar) {
	short i,n;
	char buf[241];

   if(maxchar==0)
      maxchar=MAXOPT;
	if(fgets(buf,240,ChopSource) == 0) return(ERR);
	i = 0; n = MAXOPT;
	for(i = 0; i < n; i++){
		if(buf[i] == ';') goto found;
		if(buf[i] == '\0') break;
		}
	printf("Config line missing ;: %s\n",buf);
	tap();
	return(ERR);
	found:
	i++;
	while(buf[i] == ' ') i++;
	n = i;
	for(i = 0;i <= maxchar;i++){
		line[i] = buf[i+n];
		if(line[i] == '\n') goto normal;
		}
	printf("Config line too long: %s\n",buf);
	line[maxchar] = '\0';
	return(ERR);
	normal:
	/* pad for cxl */
	//n = i;
	//for(i = n;i < maxchar;i++)
	//	line[i] = ' ';
	line[i] = '\0';
	return(OK);
	}
//========================================================================
/*	getstring()	get a string quoted in "" in file config.
	*/
short Chopper::getstring(char *ss) {
short i, err,oldconsole;
char s[STRINGLEN];

oldconsole = console; console = 'n';
while((err = feed()) != '"'&&err>0);
if(err >0){
	i=0;
	while((err=feed())!='"'&&i<STRINGLEN-1) ss[i++]=err;
	ss[i] = 0;
	if(i==STRINGLEN-1&&err!='"') while(feed()!='"');
	}
	console = oldconsole;
return (err<=0?ERR:OK);
}
//========================================================================
//geteos(iin)  get end of statement - flush away a statement when an error
//             has occured.
short Chopper::geteos(void) {
short type, lasttype;
char s[STRINGLEN];

lasttype = 0;
while ((type = chop(s)) != 'e') {
	if(type == 'f' && lasttype != '+' && lasttype != '-'
	&& lasttype != '/' && lasttype != '*' && lasttype != ','
	&& lasttype != '_') break;
	else lasttype = type;
	}
return(type);
}
//========================================================================
// geteol -- get end of line - flush away a line.  This is similar to
//   endline(), but both appear in old code.
short Chopper::geteol(void) {
char s[STRINGLEN];

while ((chop(s)) != 'f');
return(OK);
}
//========================================================================
short Chopper::endline(void) {
short c;
while(((c=feed()) != '\n') && c!= EOF);
return(c);
}
//========================================================================
// getd() -- get a double precision number from Chopper.
//   Go past spaces, new lines, punctuation, or names to find it.
double Chopper::getd(void) {
char s[STRINGLEN];
short type, lasttype;
double num;

lasttype = '+';
while((type = chop(s)) != 'n'&& type != 'e') 
	lasttype = type;
if(type == 'e'){
	printf(MSGUTIL(0));
	return(0);
	}
num = atof(s);
if(lasttype == '-') 
	num = - num;
lasttype = 'n';
return(num);
}
//========================================================================
//  geti() -- get an integer from Chopper.
short Chopper::geti(void) {
char s[STRINGLEN];
short type, lasttype;
short num;

while((type = chop(s)) != 'n'&& type != 'e') 
	lasttype = type;
if(type == 'e'){
	printf(MSGUTIL(0));
	return(0);
	}
num = atoi(s);
if(lasttype == '-') 
	num = - num;
lasttype = 'n';
return(num);
}
//========================================================================
/* getfl(x) -- get floating point number if present. Return value found
                by chop. The call must use a pointer to x: e.g. --
                type = getfl(iin,&x);
*/
short Chopper::getfl(float& x){
short type;
char s[STRINGLEN];
float sign;

sign = 1.;
type = chop(s);
if(type == '-'){ 
	sign = -1;
	type = chop(s);
	}
if(type == 'n')
	x = atof(s)*sign;
return(type);
}
//========================================================================
/* CHOP
   Chop up input stream into names, numbers, and operators.
   Numbers and names are returned as strings terminated with a null.
   Operators are returned as single characters. Function value is
   'a' for alphabetic strings, 'n' for a numerical string, 'f' for a
   line feed, 'c' for other control characters, 'e' for end of file,
   and the character itself for all other characters.

   NOTE: Please make EXTRA sure that the string variable you pass
   to chop is long enough to chop off the next field!
*/


short Chopper::chop(char* s) {

short c,i,j,k;

/* has anything been unchopped -- i.e. sent back to chop? */
if(ichopbuf > 0) {
	gstrcpy(s,chopbuf);
	ichopbuf = 0;
	return(chopretrn);
	}
i = 0;
while((c = feed()) == ' ' || c == '\t'); /* skip initial spaces */
if(c == -1 || c=='\0') 
   return('e');
s[0] = c;
/* operators */
if(ispunct(c) && c != '.'&& c!='\\') {
	s[1] = '\0';
	chopretrn = c;
	if(c == '#'){
		while((c= feed()) != '\n' && c != -1);
		chopretrn = 'f';
		if( c == -1) chopretrn = 'e';
		}
	else if(c == '"'){
		while((c= feed()) != '\n' && c != -1 && c != '"'){
			s[i++] = c;
			}
		s[i] = '\0';
		chopretrn = 'a';
		if(c == '\n') chopretrn = 'f';
		else if( c == -1) chopretrn = 'e';
		}
	}
else if (isdigit(c) || c == '.') {   /* it is a number*/
    while((c = feed()) != 0 && i<38 &&
        (isdigit(c) || c=='.'|| c== 'E' || (c=='+' && s[i] == 'E')  ||
        (c=='-'&& s[i] == 'E')) != 0)
       s[++i] = c;
    unfeed(c);
    s[++i] = '\0';
    chopretrn = 'n';
    }
else if(isalnum(c) || c == '\\') {  /* is it a name? */
    while((c=feed()) != 0 && i<38 &&
        (isalnum(c) || c == '.' || c== '_' || c == '$' || c == '\\' ||
          c == ':' || c == '&' || c == '!'))
        s[++i] = c;   /* these characters ('.', '_','$','\',':') are legal  */
    unfeed(c);
    s[++i] = '\0';
    chopretrn = 'a';
	}
else { /* it must be a control character */
   chopretrn = 'c';
   if(c==ESC) chopretrn = c;
   if(c=='\n') chopretrn = 'f'; /* line feed */
   s[++i] = '\0';
   }

gstrcpy(chopbuf,s);
return(chopretrn);
}
//========================================================================
// FEED
/* Feed one character at a time. This function is really the heart
   of the Chopper class.  It also handles the capability of having
   a memory of previously issued command lines.
*/

short Chopper::feed()  {

short i,i1,j,trow,tcol,imax,iold;   
/* Next 2 lines for Multiple Command Line Buffer. */
short lacklines,lackchars,shiftlines,shiftstart,presbufpos;
short oldline,isnew,commenton;
char *p,c[2],c1;
char insert = 'y';
unsigned k;
short k1,k2;

c[1] = '\0';
/* Has a character been unfeeded?*/
if(feedbufflag) { 
   feedchar = feedbuf; 
   feedbuf = 0;
   feedbufflag = 0;
   return(feedchar);
   }
if (feedchar == '\n'|| feedchar == -1) {  /* fill buffer */
	i = 0;                                /* Cursor offset in inbuf[] */
	if(console=='y'){
		oldline=linebfil;
		imax = -1; iold=0;              /* letztes Zeichen in inbuf[] */
		isnew=1;
		gettextinfo(&ta);
		do {
			feedchar = getch();
			if(feedchar == CTRL_C) {                       /* Ctrl C */
				fcloseall();
				exit(0);
				}
			else if(feedchar == BS){                     /* backspace */
				trow = wherey();
				tcol = wherex();
				isnew=1;

				if(i>imax) ++iold;
				if(i != 0){
					i--;
					j = i;
					while(j < imax+2){
						inbuf[j] = inbuf[j+1];
						j++;
						}
					if(imax >=0) imax--;
					gotoxy(--tcol,trow);
					for(j = i;j<=imax;j++)
						putch(inbuf[j]);
					putch(' ');
					gotoxy(tcol,trow);
					}
				}  // end BS
			else if(feedchar=='?') {         /* ?: show buffer contents */
				if(linebfil<0) printf("\n  buffer empty.");
				else for(j=0;j<=linebfil;) {
					cprintf("\r\n     %s",linebuf+linebpos[j]);
					if(++j<=linebfil) {
						gotoxy(40,wherey()); cputs(linebuf+linebpos[j]);
						++j;
						}
					}
				cputs("\r\n:");
	            imax=-1; i=0; iold=0; oldline=linebfil;
	            }  // end ?
			else if(feedchar==ESC) {               /* ESC: Clear line */
				trow=wherey(); gotoxy(2,trow); clreol();
				imax=-1; i=0; iold=0; oldline=linebfil;
				}
			else if (feedchar == '\000'){               /* editing keys */
				feedchar = getch();
				trow = wherey();
				tcol = wherex();
				if(feedchar=='O') {
					if(i<=imax) {                                   /* End */
					i=imax+1; tcol=i+2; gotoxy(tcol,trow); }
					}
				else if(feedchar == '='){                        /* F3 */
					if(linebfil>-1 && i>imax) {
						if(i>0 && iold>0) isnew=1;
						pinbuf=linebuf+linebpos[linebfil]+iold;
						while(*pinbuf != '\0'){
							inbuf[i]=*pinbuf;
							putch(*pinbuf++); ++i; ++iold;
							}
						imax = i-1;
						}
					}
				else if (feedchar=='G') {                       /* Home */
					gotoxy(2,trow); i=0;
					}
				else if(feedchar=='t') {                   /* Ctrl CuRi */
					while(i<=imax && inbuf[i]!=' ') { tcol++; i++; }
					while(i<=imax && inbuf[i]==' ') { tcol++; i++; }
					gotoxy(tcol,trow);
					}
				else if(feedchar=='s') {                   /* Ctrl CuLe */
					while(i>0 && inbuf[i]!=' ') { tcol--; i--; }
					while(i>0 && inbuf[i]==' ') { tcol--; i--; }
					gotoxy(tcol,trow);
					}
				else if (feedchar == 77){                /* right arrow */
					if(i>imax) { 
						if(linebfil>-1) {
							if(oldline!=linebfil || i>0) isnew=1;
							if((c1=linebuf[linebpos[linebfil]+iold++]) != '\0')	
							putch((inbuf[i++]=c1));
							if(i-1 > imax) imax = i-1;
							}
						}
					else {
						i++; gotoxy(++tcol,trow); ++iold;
						}
					}  // end 77
				else if (feedchar == 75 && i>0)  {          /* left arrow */
					if(--iold<0) iold=0;
					i--;
					if (--tcol < 1) { tcol = 1; i=0; }
					gotoxy(tcol,trow);
					}                                 /* Cursor Up/Down */
				else if(feedchar=='H' || feedchar=='P') {
					if(linebfil>-1) {
						isnew=0;
						if(feedchar == 'P')   /* CuUp */
							if(++oldline>linebfil) oldline=0;
						strcpy(inbuf,linebuf+linebpos[oldline]);
						trow=wherey(); gotoxy(2,trow); clreol();
						imax=strlen(inbuf)-1;
						inbuf[imax+1]='\r'; inbuf[imax+2]='\n';
						for(pinbuf=inbuf;*pinbuf!='\r';pinbuf++)
			         	putch(*pinbuf);
						iold=i=imax+1; tcol=i+2; gotoxy(tcol,trow);
						if(feedchar=='H')if(--oldline<0) oldline=linebfil;  /* CuDn */
				 		}
					}  // end 'H' or 'P'
				else if (feedchar==132) {  /* CtrlPgUp - clear buffer  */
					isnew=1;
					trow=wherey(); gotoxy(2,trow); clreol();
					imax=-1; i=0; iold=0;
					linebfil=-1; oldline=-1; linebpos[0]=0;
					}
				else if (feedchar == 82){                    /* insert */
					insert=(insert == 'y') ? 'n' : 'y';
					}
				else if (feedchar == 83){                    /* delete */
					isnew=1;
					if(i >=0 && inbuf[i] != '\r'){
						j = i;
						while(inbuf[j] != '\n'){
							inbuf[j] = inbuf[j+1];
							j++;
							}
						if(imax>=0) imax--;
						for(j=i;j<=imax;j++) putch(inbuf[j]);
						putch(' ');
						gotoxy(tcol,trow);
						}
					if(i>imax) ++iold;
					}
				}  // end '\000'
			else if (insert == 'y' && feedchar != '\r'){
				trow = wherey();
				tcol = wherex();
				isnew=1;
				putch(feedchar);
				k=2;
				for(j = i;j <= imax;j++) { 
               putch(inbuf[j]); 
               k++; 
               }
				imax++;
				movmem(inbuf+i,inbuf+i+1,k);
				inbuf[i] = feedchar;
				i++;
				gotoxy(tcol+1,trow);
				}  // end insert=='y'
			else {
				if(feedchar == '\r' || feedchar== '\n') {
					inbuf[imax+1]='\r'; inbuf[imax+2]='\n';
					i=imax+2;
					}
				else {
					isnew=1;
					putch(feedchar);
					inbuf[i] = feedchar; if(i>imax) imax = i;
					i++; iold++;
					}
				}  // end else
		   	if(linebfil<0) iold=0;
		   	else if(iold>0 && linebuf[linebpos[linebfil]+iold-1]=='\0')
				--iold;
			trow=wherey(); tcol=wherex(); gotoxy(73,1);
			if(insert=='n') {  /* printing Typovr in reversed mode. */
				textattr(112); 
            cprintf("Typovr");
				textattr(ta.attribute);
				}
			else cprintf("      ");
			gotoxy(tcol,trow);
			} while (feedchar != '\r' && feedchar != -1);

		/* store current command line into multiple 
		   command line buffer, shift old lines,    
		   but only if this line consists of more   
		   than RETURN (x0D0A) and has not been  
		   retrieved from the MCLB itself.
		*/
		if(i>0 && isnew) {   /*             */
			presbufpos=linebpos[linebfil+1];
			if(presbufpos+i>=LINEBLEN || linebfil>=NLINEBUF-2) {
				lackchars=max(presbufpos+i+1-LINEBLEN,0);
				lacklines=max(linebfil+3-NLINEBUF,1);
				for(shiftlines=lacklines; shiftlines<=linebfil+1 &&
				 	linebpos[shiftlines]<lackchars;++shiftlines);
				shiftstart=linebpos[shiftlines];
				linebfil-=shiftlines;
				for(j=0;j<=linebfil+1;++j)
					linebpos[j]=linebpos[j+shiftlines]-shiftstart;
				presbufpos-=shiftstart;
				movmem(linebuf+shiftstart,linebuf,presbufpos);
				}  // end if presbufpos
			pinbuf=linebuf+presbufpos;
			for(j=0;inbuf[j]!='\r';++j) *pinbuf++=inbuf[j];
			*pinbuf='\0';
			linebfil++; oldline=linebfil;
			linebpos[linebfil+1]=linebpos[linebfil]+i;
			}

		trow=wherey(); tcol=wherex(); gotoxy(73,1); cprintf("      ");
		gotoxy(tcol,trow);
		putch('\r'); putch('\n');
		}
	else
		do {
			feedchar = getc(ChopSource);
			if(feedchar == 0) continue;
			if(feedchar == '%'&& paddargs != 0){ /* fill in arguments */
			c[0] = getc(ChopSource);
			p = *(paddargs -1 + atoi(c));
			if(p==NULL) {
				cprintf("You called an add file that required argument %%%d, but you did not \n\r",atoi(c));
				cprintf("   provide it!  Hey, be a little more careful with your add files!\n\r");
				cprintf("Quitting Now...\n\r");
				exit(1);
				}
			while(*p != '\0'){
				inbuf[i++] = *p;
				p++;
				}
			}
		else inbuf[i++] = feedchar;
		} while (feedchar != '\n' && feedchar != -1);

	if(feedchar == -1) {
		if(i <= 1) return(feedchar);/* End of file*/
		else{
			inbuf[i-1] = '\r';
			inbuf[i++] = '\n';
			}
		}  // end feedchar == -1
	pinbuf = inbuf;
	/* print if we are in an add file and addprint is on */
	if(console == 'n' && addprint == TRUE) {
		i= 0;
		do {
			putch(inbuf[i]);
			} while (inbuf[i++] != '\n');
		}
	if(catching == 'y'){
		fwrite(inbuf,1,i,fpCatch);
		}
	if(save_flag == 'y'){  /* write into file for model building */
		wrinbuf(0,'b');
		}
	else if(annsaving == 'y') wrinbuf(0,'b');
	}
feedchar = *pinbuf++;
if(feedchar == '\r' )
	feedchar = *pinbuf ;   /* Do not feed CR; get the  LF. */
return(feedchar);
}
//========================================================================
/* wrinbuf - write the input buffer to a file. */

short Chopper::wrinbuf(short n, char which) {

short i;
/* write the input buffer from position n to the end.

/* if which == 'b', then save both; otherwise save only to
annsave file, if annsaving is on. */


if(saving == 'y' && which == 'b'){
	i = n;
	while(inbuf[i] != '\r' && inbuf[i]!='\n')
		putc(inbuf[i++],fpsave);
	putc('\n',fpsave);
	}
if(annsaving == 'y'){
	i = n;
	while(inbuf[i] != '\r')
		putc(inbuf[i++],fpannsave);
	putc('\n',fpannsave);
	}
return(OK);
}
//========================================================================
/* fill
/* This is a similar function like fill(), except that a shift parameter
is added, so it can deal with groups like (1979-2010), although the number
of members is still restricted to be 500 */

short Chopper::fills(short members[]) {
short shift=0;
   return  fills(members,shift);
   }

short Chopper::fills(short members[], short& shift) {

short i, n, lastn, inout, paren,type,maxel,tipo,more=1;
char lasttype,err,s[20];

shift = -9999;
inout = 1;
paren = 0;
lasttype = 0;
err = 'n';
maxel = 0;
lastn = -9999;

while(more){
	type = chop(s);
	if(type == 'f' && lasttype != ',') break;
	lasttype = type;

	switch(type){
		case 'n':
			n = atoi(s);
			// the following three lines are the changes over fill();
			if(shift==-9999)
				shift = n-1;
			n -= shift;
			members[n] = inout;
			lastn = n;
			if(n > maxel) maxel = n;
			break;
		case '-' :
			tipo = chop(s);
			if(tipo != 'n'){
				printf("\nA - must be followed by a number.");
				err = 'y';
				break;
				}
			else if(lastn == -9999){
				printf("\nA number must procede a -.");
				err = 'y';
				break;
				}
			n = atoi(s)-shift;
			for (i = lastn; i <= n; i++)
				members[i] = inout;
			if(n > maxel) maxel = n;
			break;
		case '(' :
			if(inout == 1) inout = 0;
			else inout = 1;
			paren++;
			break;
		case ')' :
			if(inout == 1) inout = 0;
			else inout = 1;
			paren--;
			if(paren<0) more=FALSE;  // catch right hand side paren ?
			break;
		case ',':
			break;
      case 'e':  // end of string '\0' in buffer also returns 'e'
         more=FALSE;
         break;
		default :
			printf("\nUnrecognized element %s",s);
			err = 'y';
			break;
		}
	if(err == 'y') break;
	}
return(maxel);
}

char *gstrcpy(char *target, char *source) {
while((*target++ = *source++)!= 0);
return(target);
}

