//  COMPBNK.H -- Class declarations for comparessed G data bank objects.
#if !defined(COMPBANK_H)
#define COMPBANK_H 1

#include "databank.h"

struct cbnkHeader {
   char bnktitle[80];
   short nseries;
   unsigned long position;
   };

class CompSeries {
public:
   unsigned char BaseYear, FreqPeriod, SlashDecplaces;
   short Ndif;
   long FirstObs;
   short *Differences;
   short npy, nobs, freq, period;
} ;

// We may want to create an abstract bank class that handles all types
//   of banks.

class CompBank : public DataBank  {   
// Object to handle transactions with compressed G bank.

protected:
   short ncin;
   char *names;
   unsigned long *indx;
   unsigned long position;


public:
	CompSeries cs;
	// constructors
	CompBank(const char *);  // Open file name, initialize members.

	// destructor
	~CompBank();

	// Get series function.
	short getser(char *nam, float *f,short SeriesLength=-1);
	short ListNames(FILE*,char*,short wide=1);
	short Announce(short bankno);
	short findname(char *nam);

   virtual char *Setbnktitle(const char *s);

	// inline functions
	short Getnobs(void)   {return nobs;}
};

#endif // end COMPBANK_H class definitions

