
#pragma hdrstop
#include <condefs.h>

//---------------------------------------------------------------------------
#pragma argsused
char *Version="Version 2.6";    // Interdyme Version
/*
        SLIMDYME.CPP -- This is a skeleton version of the Dyme program,
        that does not do anything.  Rather it shows what is the minimum
        code needed to comprise a Dyme model, and indicates where the
        various pieces of the code would go. 
*/

#define GLOBAL
#include "dymesys.h"  // All includes for general Interdyme "infrastructure".
#if defined(INCL_MACRO)
#include "tseries.inc" // Re-written each time by IDBUILD.
#include "heart.h"
#endif
#include "user.h"     // All global variables for user model.

#define MemRequired 350
// Put here the amount of memory in Kbytes that your program will need to run.

// Function prototypes:
short Initialize(short argc, char **argvec);
void loop(void);
void new_fail(void);
int c_break(void);

void main(int argc, char **argvec)
{
        short err;
        char *cp,drive[5],dir[120],fname[20],ext[5];
        time_t beginTime, endTime;  // to calculate time of run.
        long core;
        #ifdef INCL_CORELEFT
        core = farcoreleft();
        #endif
        //cprintf("Memory upon starting the model: %ld bytes.\n\r",core);
        //tap();
        beginTime = time(NULL);
        // Make the root name of the cfg file the same as the program.
        fnsplit(argvec[0],drive,dir,fname,ext);
        strcat(fname,".cfg");
        strcpy(CfgFileName,fname);
        if(argc > 1) 
                strcpy(CfgFileName,argvec[1]);
		printf("Config file: %s\n",CfgFileName);
        // Initialize opens Vam file, Macro file, and fixes files...
        if((err=Initialize(argc,argvec))==ERR) {
                exit(1);
                }
#if defined(INCL_MACRO)
        // read number of variables and stochastic indicator for each equation
        nequ = coefdim();
        // If we are doing a deterministic or optimizing simulation, call coefread
        // to read the regression coefficients of the macro equations and, if optimizing,
        // the .opt file which specifies the objective function and which coeffients
        // in which equations are to be varied, and the initial stepsizes.

        // If we are not doing stochastic simulation, read the coeficients
        if(num_draw == 0) coefread();
        // Otherwise -- that is, if we are doing stochastic simulations -- read
        // heart.dat and generate the first set of random coefficients.

        else coefgen();
#endif
        loop(); err=err;

        fin:
        // Delete GLOBAL variables:
/*
        #if defined(INCL_SEIDEL)
        #if !defined(INCL_IVECTOR)
          if(triang)
                delete triang;
        if(ptriang)
                delete ptriang;

        #endif
        if(outfix)
                delete[] outfix;
        #endif

        #if defined(INCL_MACRO)
        if(Tsptr)
                delete Tsptr;
        #endif
*/
        endTime = time(NULL);
        printf("Total execution time: %.0f seconds\n",
            difftime(endTime,beginTime) );
        }
/* ====================================================================*/
int c_break(void)  {
        cprintf("Control-Break pressed.  Program aborting ...\n");
        exit(0);
        return 0;
}
/* ====================================================================*/
void new_fail(void) {
        // memory exhausted

        cout << "\n\nWARNING!!\n";
        long core = MemoryLeft();
        cout << "Only " << core << " bytes left when trying to allocate memory.\n";

        cout << "Check your memory available using the DOS mem command\n";
        cout << "You need at least " << MemRequired << " K available to run this program.\n";
        cout << "Try taking out some TSR's or device drivers to make more memory available.\n";
        exit(1);
}
//==============================================================================
short InitGlobals(void) {
        setrho='n';
        useall='y';
        maxit=25;
        debug=32000;
        #if defined (INCL_SEIDEL)
        #if !defined (INCL_IVECTOR)
        //triang=0;
        //ptriang=0;
        #endif
        //secimp=0;
        //outfix=0;
        #endif

        #if defined(INCL_FIX)
        fixesPlace=-1;  // flag for error if no fix vector declared
        #endif

        return 0;

}
//==============================================================================
// This routine initializes the Vam file, Macro bank, and fixes files.
//   It is put down here, as it is more likely to change in the development
//   of Interdyme than the main() function.

short Initialize(short argc, char **argvec) {
        short err,check,ns_ws,gstart;
        char *cp;
        #ifdef INCL_CTRLBRK
        ctrlbrk(c_break);  // handles pressing of {Ctrl}-C or {Ctrl}-{Brk}
        #endif
        #ifdef DJGPP
        setcbrk(1);
        #endif
        set_new_handler(new_fail); // called when new fails
        InitGlobals();
        _control87(MCW_EM,MCW_EM);/*mask arithmetic problems*/
        //Read the dyme.cfg file
        if(configure() == ERR){
                goto cleanup;
                }
        // maxit is the maximum number of iterations of the entire loop per year
        // debug is the year in which to start debugging printing.

        #if !defined(OS2COMPILE)
        clrscr();
        #endif
        // vf[0] is the default simulation destination file.  Other VamFiles
        //   may also be opened.
        vf[0].OpenVam(VamFileName); // vf declared globally.
        // We seem to be having problem with GCC inline:
        //check=vf[0].IsErr();
        //check=vf[0].IsOpen();
        if(!vf[0].IsOpen()) {
        printf("\nCannot open %s for update.",VamFileName);
        goto cleanup;
        }
        // This is an example of how to open a second Vam file:
        /*
        vf[1].OpenVam("test"); 
        if(!vf[1].IsOpen()) {
                printf("\nCannot open %s for update.","test.vam");
                goto cleanup;
                }
        */
        vf[0].Setrunname(RunTitle);     // Put runtitle in Vam File.
          // (VamFile destructor automatically writes it out)
        InitMat(vf[0]); // Read information from VamFile.
        #if defined(INCL_SEIDEL)
        #if !defined(INCL_IVECTOR)
        ReadTriang(); //Read the triangularization vector
        #endif
        #endif

        #if defined(INCL_FIX)
        #if defined(INCL_GROUPS)
        fb.Load(VecFixFileName,vf[0]);
        #ifdef INCL_SEIDEL
        ReadOutFix(); // Read the type of fix to be used for each output
        #endif
        /* read group definitions */
        GroupShelter.Load();    // Reads from GROUPS.BIN 

        fb.PutInGroupNums();    // Fixes come with group NAMES. Find 
                                                  // and keep the corresponding number.
        #endif
        #endif

        #if defined (INCL_MACRO)
        // Get the name of the G bank which contains the Tseries variables.
        if(strcmp(GbankName,"none") != 0){
         // Open up the model G Bank, and load the Tseries variables:
        gb.AssignBank(GbankName);  // Assign dyme G Bank. (gb is global)
                 // (gb is already declared in dyme.inc.)
        gstart=gb.GetBaseYr();
        #if defined (INCL_EQFIX)
        BaseDate = GDate(gstart,1,1);  // Base date for equation fix find()
        fdate1 = BaseDate;
        #endif
        gb.Setbnktitle(RunTitle);
        GShift = gstart-(short)vf[0].Getstartdate();
        // Set up Tsptr vector, which points to all Tseries objects.
        ns_ws = gb.Getnseries();
        Tsptr = new Tseries *[ns_ws];
        for(short i = 0; i < ns_ws; i++)
         Tsptr[i] = 0;
        // Read in the Teries from the model G Bank.
        tserin(); 
        // Open up fix bank, containing macrofixes. (mfbank & mfh declared in 
        //              dyme.inc.
		MacFixesRead = 0;
		if(strcmp(MacFixFileName,"none") != 0){ //Test added by CA 2005 Aug23
        	if(mfbank.Load(MacFixFileName)==-1)  {
                MacFixesRead=0;
                cprintf(" Macrofix File %s doesn\'t exist.  Macro fixes will be ignored.\r\n",
                         MacFixFileName);
                tap();
                }
		      else MacFixesRead=1;
			}
        // Set up Macro Fix Home, which is used by the macro fix function,
        //                      modify().
        if(MacFixesRead) 
                mfh.Load(mfbank,gb);
                }
        #endif
        err=err;  gstart=gstart; argc=argc; cp=argvec[0]; cp=cp; // to remove warnings
        return 0;
        cleanup:
        #if !defined(OS2COMPILE)
        #if !defined(DJGPP)
        fcloseall();
        #endif
        #endif
        cp = argvec[0];  argc=argc;  // remove warnings
        return(ERR);
}


