/* EQUATION.H 
	This class implements the detached coefficient equation feature
	of Interdyme.	
*/

#if (!defined(EQUATION_H))
#define EQUATION_H 1

class Vector;  // references required for update function.
class Matrix;

class Equation{
 public:
	char *filename;  // store to identify the object.
	short neq;	//number of equations = number of rows of matrix
	short ncol;	// number of columns in coef matrix
	short rhostart;
	short eqcount;  // This will help us in the forecasting routines.
	char *types;	// type is used to distinguish equations of different forms
	float *rhos;
	float *errors;
	float **coefs;
	short *sectors;  //sectors[i] is the sector to which equation i applies

       Equation(char *filename, int yr=0);
	Equation();// default, for making an equation global
       ~Equation();
       int r(char *filename,int yr = 0);//resize and load from file
       Equation(Equation&); // copy constructor.
	float * operator [] (short i);	// range checked element 
	char type(short i); // returns the "type" for the equation for sector i
	float rho(short i);  // returns the rho for the equation for sector i
	// Perform rhoadjustment 
	float rhoadj(float value, float xi, short i, float rhoval=2); 
	short Equation::sec(short i);
	short Equation::GetLoc(short sec);
	void SetConstantTerm(void);
	void ZeroRho(void);
       void SetRho(float value);
	};

#endif  // end EQUATION_H class definitions.
