// GDATE.CPP -- Functions for Date and DateStruct class.
/* This constructor fills up a date class by using a datestring 
	Dates are stored internally as 4-digit numbers, but may be printed either
	as 4-digit or 2-digit numbers.  Dates like 2010 are printed as '10', 
	with two digits, instead of the old '110' format.

*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
#include <malloc.h>

#include "gdate.h"
#define NL  printf("\n");
#define TRUE 1
#define FALSE 0
// comment out next line when linking GDate class to other main program.
//#define TEST       // keep this in when in test mode (compiles main)

#ifdef TEST
// test program, for checking GDate functions:
void main(int argc, char **argv) {

GDate d1, d2(93,3,4), d3(95,2,4);
GDate d4("98.2"), d5(d4);
GDate d6,d7;
GDate a1("98"), a2("92.0");
GDate m1("93.004"), m2;
GDate m3;
int ob1, ob2;
char s[40];
float xdate, ydate;

d1=d4;

ob1=d4.ObNo(d2);
ob2=d5.ObNo(d1); // -> should be 0

ob2 = d4 - d3; // look in dbgr
ob2 = d3 - d4;
printf("d1 is %s.  d2 is %s\n",d1.DateString(s), d2.DateString(s));
// test float converter
d3=96.2;  // d3=96.2;
m2 = 96.002;
// test float converter function.
// Test increment and decrement operators:
printf("Incrementing...\n");
for(m3=m2;m3<m2+24;m3++)  {
   printf(" m3 is "); m3.Print(stdout); NL
   }
printf("Decrementing...\n");
for(m3;m3>GDate(96.001);m3--) {
   printf(" m3 is "); m3.Print(stdout); NL
   }
xdate=float(d3);
ydate=float(m2);
printf("d3 is %s. \n",d3.DateString(s) );
printf("xdate is %f   ydate is %f\n",xdate,ydate);

printf("d3 %s equal to d2.\n", (d3==d2)? "is" : "isn\'t");

printf("ob1 is %d.  ob2 is %d.\n",ob1,ob2);
printf("Annual, Base: 92.0 to 98 is position %d.\n",a1.ObNo(a2) );
printf("Monthly, Base 93.004 to 95.012 is position %d.\n",m2.ObNo(m1) );
printf("Now test printing function:\n\n");
printf(" d1 is "); d1.Print(stdout); NL
printf(" a1 is "); a1.Print(stdout); NL
printf(" m2 is "); m2.Print(stdout); NL
d6 = d1 + 10;
m3 = m2 - 5;
printf("d1 + 10 is "); d6.Print(stdout); NL
printf("m2 - 5 is "); m3.Print(stdout); NL
m3 += 4;
printf("m3 += 4 yields: "); m3.Print(stdout); NL
m3 -= 10;
printf("m3 -= 10 yields: "); m3.Print(stdout); NL
}
#endif

//=======================================================================
int GDate::IsDate(void) {
if( (freq==1||freq==2||freq==4||freq==12) && year>0)
   return 1;
return 0; 
}


// Here are some operators:
//=======================================================================
// convert GDate to float
GDate::operator float(){
float x;
x = float(year);
if(freq==1)
   return(x);
else if(freq==4) {
   x += period * .1;
   return(x);
   }
else if(freq==12) {
   x += period *.001;
   return(x);
   }
return 0;
}
//=======================================================================
GDate::operator char*() {
DateString(scratch);
return scratch;
}
//=======================================================================
// GDate copy constructor.
GDate::GDate(GDate &d) {
year=d.year;
freq=d.freq;
period=d.period;
strcpy(scratch,d.scratch);
}
//=======================================================================
GDate& GDate::operator = (const GDate& gd) {
int f,y,p;
if(this == &gd)
   return *this;
freq = gd.freq;
year = gd.year;
period = gd.period;
strcpy(scratch,gd.scratch);
return *this;
}
//=======================================================================
int GDate::operator == (GDate& gd) {
if(gd.freq==freq && gd.year==year && gd.period==period) 
	return TRUE;
return FALSE;
}
//=======================================================================
int GDate::operator < (GDate& gd) {
if(year < gd.year) 
	return TRUE;
if(year > gd.year)
	return FALSE;
if(freq == gd.freq) { 
	if(period<gd.period)
		return TRUE;
	return FALSE;
	}
// When frequencies are not equal:
printf("Two dates of different frequencies cannot be compared.\n"); 
return -1;
}
//=======================================================================
int GDate::operator <= (GDate& gd) {
if(year < gd.year) 
	return TRUE;
if(year > gd.year)
	return FALSE;
if(freq == gd.freq) { 
	if(period<=gd.period)
		return TRUE;
	return FALSE;
	}
// When frequencies are not equal:
printf("Two dates of different frequencies cannot be compared.\n"); 
return -1;
}
//=======================================================================
int GDate::operator > (GDate& gd) {
if(year > gd.year) 
	return TRUE;
if(year < gd.year)
	return FALSE;
if(freq == gd.freq) { 
	if(period>gd.period)
		return TRUE;
	return FALSE;
	}
// When frequencies are not equal:
printf("Two dates of different frequencies cannot be compared.\n"); 
return -1;
}
//=======================================================================
int GDate::operator >= (GDate& gd) {
if(year > gd.year) 
	return TRUE;
if(year < gd.year)
	return FALSE;
if(freq == gd.freq) { 
	if(period>=gd.period)
		return TRUE;
	return FALSE;
	}
// When frequencies are not equal:
printf("Two dates of different frequencies cannot be compared.\n"); 
return -1;
}
//=======================================================================
// This '+' operator may be easier than (basedate,int) constructor when
//   trying to get a date a certain distance from a basedate.  It is also
//   useful in other contexts.  This operator has also been designed to 
//   handle negative offsets.  Then the '-' operator can be written 
//   easily.  (see below)

GDate GDate::operator + (int obsno) {

int yeardif, offset;
GDate Temp;

yeardif=obsno/freq;
offset=obsno%freq;
Temp.freq=freq;
Temp.year=year+yeardif;
if(Temp.year<25)
   Temp.year += 2000;
else if(Temp.year < 1900)
   Temp.year += 1900;
Temp.period=period+offset;
if(Temp.period>=freq) {
	Temp.year++;
	Temp.period-=freq;
	}
if(Temp.period<=0) {
	Temp.year--;
	Temp.period+=freq;
	}
return (Temp);
}
//=======================================================================
GDate& GDate::operator +=(int obsno) {
int yeardif, offset;

yeardif=obsno/freq;
offset=obsno%freq;
year+=yeardif;
if(year<25)
   year += 2000;
else if(year < 1900)
   year += 1900;
period+=offset;
if(period>=freq) {
	year++;
	period-=freq;
	}
if(period<=0) {
	year--;
	period+=freq;
	}
return (*this);

}
//=======================================================================
GDate& GDate::operator -=(int obsno) {
*this += (-obsno);
return(*this);
}
//=======================================================================
GDate& GDate::operator ++() {
period++;
if(period>freq) {
   period=1;
   year++;
   }
return *this;
}
//=======================================================================
GDate& GDate::operator --() {
period--;
if(period<1) {
   period=freq;
   year--;
   }
return *this;
}
//=======================================================================
GDate GDate::operator - (int obsno) {

int yeardif, offset;
GDate Temp;

Temp = *this + (-obsno);
return(Temp);
}
//=======================================================================
// Constructor from float.  Works much like previous G stuff.
GDate::GDate(float dateb) {

float  datec;
int ll,em,m,j,k,offset; 

m = 1000;
datec = dateb + .0005;
em = m;
k = datec;
j = datec * em;
j = j - k * m;
year = (int)dateb;
if(year<25)
   year += 2000;
else if(year < 1900)
   year += 1900;
/* figure out freq, the number of observations per year */
freq = 1;
period=1;
if (j > 0 && j <= 13){/* monthly data */
   freq = 12;
   period=j;
   }
else if (j > 13 && j < 450){/* quarterly data */
   freq = 4;
   j = j/100;
   period=j;
   }
else if (j > 450){ /* semi-annual data */
   freq = 2;
   j = (j - 400)/100;
   period=j;
   }
// Operator = copies scratch.  Make sure it is set to NULL!
strcpy(scratch,"");
}
//=======================================================================
// Constructor from float, with frequency forced.  This is done especially
//   for the REA format, since their monthly format is different.   
// (They use 92.10 to represent October, 1992, whereas with our format, 
//   this would be confused with 1st quarter.)
GDate::GDate(float dateb, int f) {
float diff, xper;
freq = f;
year = (int)dateb;
if(year<25) {
   year += 2000; dateb += 2000.;
   }
else if(year < 1900) {
   year += 1900; dateb += 1900.;
   }
period=1;
if(freq==4) {
   diff = dateb-(float)year;
   xper = diff * 10. + .0005;
   period = (int)xper;
   }
else if(freq==12) {
   diff = dateb-(float)year;
   xper = diff * 100. + .05;
   period = (int)xper;
   }
strcpy(scratch,"");
}
//=======================================================================
GDate::GDate(char *DString) {
char *cp,SYear[10], SPeriod[10];
char ds[20];
strcpy(ds,DString);
cp=strchr(ds,'.');
if(cp==NULL) { // annual
	freq=1;
	year=atoi(ds);
   if(year<25)
      year += 2000;
   else if(year < 1900)
      year += 1900;
	period=1;
	}
else {
	strcpy(SPeriod,cp+1);
	*cp='\0';
	strcpy(SYear,ds);
	year = atoi(SYear);
   if(year<25)
      year += 2000;
   else if(year < 1900)
      year += 1900;
	period = atoi(SPeriod);
	if(period==0) {
		freq=1;
		period=1;
		}
	else if(strlen(SPeriod)==1)
		freq=4;
	else if(strlen(SPeriod)==3)
		freq=12;
	else {
		printf("Error in Date: %s.  Invalid period.\n",DString);
		}
	}
strcpy(scratch,"");
}
//=======================================================================
GDate::GDate(int y,int p,int f) {
if(y<1900 && y>199) {
	printf("Year doesn't look right: %d.\n",y);
	return;
	}
if( !(f==1 || f==4 || f==12) ) {
   if(y==0&&p==0&&f==0)
      goto nodate;
   else {
   	printf("Frequency must be 1, 4, or 12.\n");
   	return;
      }
	}
if(p<1 || p>f) {
	printf("Period must be >= 1, <= freq.\n");
	return;
	}

year=y;
if(year<25)
   year += 2000;
else if(year < 1900)
   year += 1900;
period=p;
freq=f;
strcpy(scratch,"");
return;
nodate:
strcpy(scratch,"");
year=y; period=p; freq=f;
}
//=======================================================================
/* The following functions assume that BaseDate's are never greater than
	the dates being used.  But this class could be generalized to handle
	negative obno's.
*/
GDate::GDate(int obsno, GDate& BaseDate) {
int yeardif, offset;
freq=BaseDate.freq;
yeardif=obsno/freq;
offset=obsno%freq;
year=BaseDate.year+yeardif;
if(year<25)
   year += 2000;
else if(year < 1900)
   year += 1900;
period=BaseDate.period+offset;
if(period>=freq) {
	year++;
	period-=freq;
	}
if(period<=0) {
	year--;
	period+=freq;
	}
strcpy(scratch,"");
}
//=======================================================================
// This '-' operator is somewhat like ObNo, but also handles negative
//   offsets.  It is defined as the difference between two dates, 
//   in terms of number of periods.

int GDate::operator - (GDate& date){
int yeardif, offset;
if(date.freq != freq)
	return(-1);
yeardif = year - date.year;
offset = period - date.period;
return(yeardif*freq+offset);
}
//=======================================================================
/* ObNo -- This function gets the 0-based observation number based on
	BaseDate.  For example, if the current date is 94.2, and the BaseDate
	is 92.1, the observation number is 9.  Note that both the Date and
	the BaseDate must have the same frequency, and that the Date must be
	greater than or equal to the BaseDate.  If there is an error, an
	negative error code will be returned.  Otherwise ObNo will return
	0 or greater.
*/
int GDate::ObNo(GDate& BaseDate) {
int yeardif, offset;
GDate me = GDate(year,period,freq);
if(freq != BaseDate.freq)
	return(-1);
if(BaseDate>me)
	return(-2);
yeardif = year - BaseDate.year;
offset = period - BaseDate.period;
return(yeardif*freq+offset);
}
//=======================================================================
/* DateString -- Function to print date into a G-date string.  Make sure
	calling program has allocated enough memory to string s!  DateFormat
   argument can be:
      '2' - print all 2-digit dates.  2000 -> 00
      '3' - print old style G dates   2000 -> 100
      '4' - print all 4-digit dates   2000 -> 2000

*/
char *GDate::DateString(char *s, char DateFormat) {
int printyear;
printyear=year;
char YearString[8];
char df;

if(DateFormat!='2'&&DateFormat!='3'&&DateFormat!='4')
   df='2';
else df=DateFormat;

if(df=='2') {
	if(year>=2000) printyear=year-2000;
	else printyear=year-1900;
   sprintf(YearString,"%02d",printyear);
	}
else if(df=='3') {
   printyear=year-1900;
   sprintf(YearString,"%3d",printyear);
   }
else 
   sprintf(YearString,"%4d",printyear);
if(freq==1)
	sprintf(s,"%s",YearString);
else if(freq==4)
	sprintf(s,"%s.%d",YearString,period);
else if(freq==12)
	sprintf(s,"%s.%03d",YearString,period);
return(s);
}
//=======================================================================
/* This function is very simple at the moment.  It could be improved to
	do field width, and justification.
*/
int GDate::Print(FILE *tbl) {
char s[25];
fprintf(tbl,DateString(s));
return(0);
}
//=======================================================================
// Now here are some DateStruct functions:
/* This gets a DateStruct out of a string consisting of either one date,
	or two dates, separated by a '-'.
*/

DateStruct::DateStruct(char *s) {
char *cp,Date1[10], Date2[10];
char ds[20];
strcpy(ds,s);
cp=strchr(ds,'-');
if(cp==NULL) { // only 1 GDate
	growth=0;
//	GDate gd(s);
	DStart=s; // try this
	}
else {
	strcpy(Date2,cp+1);
	*cp='\0';
	strcpy(Date1,ds);
	growth=1;
//	GDate gd(Date1), gd2(Date2);
	DStart=Date1;  DEnd=Date2;  // perform implicit string to Date conversion.
	}
}
//=======================================================================
DateStruct::DateStruct(GDate& d, GDate& e) {
growth=1;
DStart=d;
DEnd=e;
}
//=======================================================================
/* DateString -- Function to print date into a G-date string.  Make sure
	calling program has allocated enough memory to string s!  FourDigit argument
	specifies whether or not to print the year parts as 4 digits.  
	Note: if FourDigit is 0, all dates are two digits.  If it is 2, all dates
	are 4 digits.  If it is 1, levels are 4 digits, but growth rate expressions
	are 2-digits, separated by a dash.

*/
char *DateStruct::DateString(char *s, char DateFormat) {
int y1,y2, p1,p2,f;

f=DStart.freq;
if((DateFormat!='2') || (growth&&DateFormat!='4')) {
	if(DStart.year>=2000) y1=DStart.year-2000;
	else y1=DStart.year-1900;
	}
else 
	y1=DStart.year;
p1=DStart.period;
if(growth) {
	if(DateFormat!='4') {  // force to be 2 digit
		if(DEnd.year>=2000) y2=DEnd.year-2000;
		else y2=DEnd.year-1900;
		}
	else {  // '2' is 2-digit, '4' is 4-digit, 'm' is mixed.
		y2=DEnd.year;
		}
	p2=DEnd.period;
	}
if(growth) {
	if(f==1) {
		if(DateFormat!='4')
			sprintf(s,"%02d-%02d",y1,y2);
		else sprintf(s,"%4d-%4d",y1,y2);
		}
	else if(f==4) {
		if(DateFormat!='4')
			sprintf(s,"%02d.%d-%02d.%d",y1,p1,y2,p2);
		else sprintf(s,"%4d.%d-%4d.%d",y1,p1,y2,p2);
		}
	else if(f==12) {
		if(DateFormat!='4')
			sprintf(s,"%02d.%03d-%02d.%03d",y1,p1,y2,p2);
		else sprintf(s,"%4d.%03d-%4d.%03d",y1,p1,y2,p2);
		}
	return(s);
	}
else {
	if(f==1) {
		if(DateFormat!='2')
			sprintf(s,"%02d",y1);
		else sprintf(s,"%4d",y1);
		}
	else if(f==4) {
		if(DateFormat!='2')
			sprintf(s,"%02d.%d",y1,p1);
		else sprintf(s,"%4d.%d",y1,p1);
		}
	else if(f==12) {
		if(DateFormat!='2')
			sprintf(s,"%02d.%03d",y1,p1);
		else sprintf(s,"%4d.%03d",y1,p1);
		}
	return(s);
	}
}
