// GDATE.H - Class for handling DateStrings, DateStructs, and new ObNo.

#if !defined(GDATE_H)
#define GDATE_H 1

/*	This Date class repeats some of the functionality of the old G and VAM
	date handling routines, but handles input of both single dates or
	intervals as strings, simplifying the calculation of table cells in the
	compare program.
*/
#define NODATE GDate(0,0,0)

class GDate {
 public:
	int year, period, freq;
 private:
   char scratch[20];  // space for formatting strings
 public:
// Constructors and Destructor:
	GDate(void)	{year=0;period=0;freq=0;strcpy(scratch,"");}	// Default constructor.
	// constructor to fill up Date:
	GDate(int y,int p,int f);
	GDate(float);  
   GDate(float dateb, int f);
	// copy constructor:
	GDate(GDate &d);
	GDate(char *);		// String to date converter.
	GDate(int obsno, GDate &BaseDate); /* Get date from base date and
				observation number. */
	~GDate(void) {}
	int ObNo(GDate &BaseDate); /* Get observation number of this date, given
				the base date. (see also '-' operator) */
	char *DateString(char *,char DateFormat='2');
	int Print(FILE *);
   int IsDate(void);

	// operators::
   GDate& operator = (const GDate&);
	int operator == (GDate&);
	int operator <  (GDate&);
	int operator >  (GDate&);
	int operator <= (GDate&);
	int operator >= (GDate&);
	GDate operator + (int);
	GDate operator - (int);
	int operator - (GDate&);  // like ObNo.
	GDate& operator += (int);
   GDate& operator -= (int); 
   GDate& operator ++();
   GDate& operator --();
   operator float();
   operator char*();
	};

/* In DateStruct, growth is 1 if two dates are given, and a growth rate
	calculation will be desired.  DStart and DEnd are of course, the
	starting and ending dates, and must be of the same frequency.
*/
class DateStruct {
  public:
	int growth;
	GDate DStart, DEnd;

	DateStruct(void) {GDate ds,de; growth=0; DStart=ds; DEnd=de;}
	DateStruct(char *);
	char *DateString(char *, char DateFormat);
	DateStruct(GDate& d, GDate& e);
	~DateStruct(void) {}
	};

#endif
