//  HASHBANK.H -- Class declarations for comparessed and hashed 
//     G data bank objects.
#if !defined(HASHBANK_H)
#define HASHBANK_H 1

#include "databank.h"

struct hbnkHeader {
   char bnktitle[80];
   short nseries;
   unsigned long position;
   };

class HashSeries {
public:
   unsigned char BaseYear, FreqPeriod, SlashDecplaces;
   short Ndif;
   long FirstObs;
   short *Differences;
   short npy, nobs, freq, period;
} ;

// We may want to create an abstract bank class that handles all types
//   of banks.

class HashBank : public DataBank  {   
// Object to handle transactions with hashed G databank.

protected:
   unsigned short ncin;
   unsigned long lnseries, ns_hin;
   char *names;
   unsigned long *indx;
   unsigned long position;
   unsigned short nbins, *nsb, *ncharb;
   unsigned long *posbin;

public:
   HashSeries cs;
   // constructors
   HashBank(const char *);  // Open file name, initialize members.

   // destructor
   ~HashBank();

   // Get series function.
	short getser(char *nam, float *f,short SeriesLength=-1);
   short GetFirst(float *ss);
   short Retrieve(long psn, float *f);
	short ListNames(FILE*,char*,short wide=1);
	short Announce(short bankno);
   // findname for HashBank returns position
   unsigned long findname(char *nam);
   unsigned long findname(short bin, short num);
   unsigned short hash(char *s);

   virtual char *Setbnktitle(const char *s);

   // inline functions
   short Getnobs(void)   {return nobs;}
};


#endif // end HASHBANK_H class definitions

