/* rhs -- calculate expressions for equation fixer in Interdyme.

*/

#include "dymesys.h"

#if defined(INCL_EQFIX)

// Prototypes used in rhs:
double lagran(float xx, float *x, float *y, short n);
short polate(float *f, float w[][4], float *temp, short nsubdiv, 
	short fo, short to, short wo, char end_of_period);
short lagrange(float x, float *w, float *p) ;
char *gstrcpy(char *target, char *source);
short IsMissing(float);
short percent2level(float *f, FILE *iin, char *pend);
short pctcmd(float *f, FILE *iin, char *pend);
short meanfunc(float *f, FILE *iin, char *pend); 
short GetTseries(char *name, float ss[]);
short GetVecCurObs(char *name, float& x);


const char UseMissing='y';
const short freqdefault=1;
//===============================================================
// If quiet is TRUE, rhs won't complain about not finding series.

short Chopper::rhs(float *f, char *pend, short quiet) {   

short rhsreturn;   
char op_stack[3],s[LLINE],c;
double fval;
GDate bd;
float *ss, *a, *b;
short  err, i, type, lasttype, go,nopyf,nopya,nopyb;    
short osp; /* osp = operation stack pointer, points to top operation
				         on stack */
char *ipend;

ipend = pend;
rhsreturn = OK;

//ss = vector(0,Interval);

a = vector(0,Interval+200);
b = vector(0,Interval+200); 

osp = 0;
for (i = 0; i<Interval; i++) {
  f[i] = 0;  a[i] = 0;  b[i] = 0;
  }

op_stack[0] = '+';
go = GO;
type = 0;
nopyf = nopya = nopyb = 0;

while(go == GO) { 
	lasttype = type;
	type = chop(s);
   if(type != 'e') {  // when reading from a string, at '\0'
   	pend = gstrcpy(pend,s);
   	pend--;
      }

	switch (type) {
		case '=': 
			rhsreturn = '=';
			go = STOP;
			pend--; 
			break;
		case 'a':  /* got a variable name; put the series in b */
			// if find is to be a member of Chopper, we have to pass Chopper somehow.
			if(( find(s,pend,b))== ERR){
            if(!quiet) {
   				cprintf("\r\nTap a key to continue.  ESC to exit.");
   				c = getch();
				   if(c==ESC){
					   geteos();
					   rhsreturn = ESC;
					   goto done;
					   }
               else continue;
               }
            continue;
				} 
			nopyb = 1;  // Annual, til we get frequencies in Interdyme.

			pend = pend + strlen(pend);
         /* if a * or / is on top of the operator stack, do the
            operation and put result in  vector a . */
			if((muldiv(a,op_stack,&osp,b,&nopya,nopyb))==ERR) {
				rhsreturn = ERR;
				goto done;
				} 
			break;
         	   
		case 'n': /* got a constant; put it into all elements of b */
			fval = atof(s);
			for (i = 0; i< Interval; i++) 
				b[i] = fval;
			nopyb = 1;
			if((muldiv(a,op_stack,&osp,b,&nopya,nopyb))==ERR) {
				rhsreturn = ERR;
				goto done;
				}
			break;
     		
		case '(':
			if((rhs(b,pend)) != ')'){
				printf(MSGRHS(0));
				geteos();
            rhsreturn = ERR;
            go = STOP;
            break;
            }
  			nopyb = npy = 1;
         if((muldiv(a,op_stack,&osp,b,&nopya,nopyb))==ERR) {
				rhsreturn = ERR;
				goto done;
				}
         else{
           	while(*pend != '\0') pend++;
           	}
         break;

		case ')':
			rhsreturn = ')';
			go = STOP;
			break;

		case ',':
			rhsreturn = ',';
			go = STOP;
			(pend)--;
			break;

		case '@':
			if((functions(b,pend)) != OK){
				go = STOP;
				rhsreturn = ERR;
				break;
				}
			nopyb = npy;
			if((muldiv(a,op_stack,&osp,b,&nopya,nopyb))==ERR) {
					rhsreturn = ERR;
					goto done;
					}
			break;

		case '*':
			if((rhssyn(lasttype))== ERR) {
				rhsreturn = ERR;
				goto done;
				}
			op_stack[++osp] = '*';
			break;

		case '/':
			if((rhssyn(lasttype))== ERR) {
				rhsreturn = ERR;
				goto done;
				}
			op_stack[++osp] = '/';
			break;

		case '-': /* same as + */
		case  '+':
			if((rhssyn(lasttype))== ERR) {
				rhsreturn = ERR;
				goto done;
				}
			addsub(f,op_stack,&osp,a,&nopyf,nopya);
			op_stack[++osp] = s[0];
			break;

		case  'f': /* found line feed ( = \n in C terms) */
			if(lasttype == '+' || lasttype == '-' || lasttype == '*' ||
				  lasttype == '/' || lasttype == '_' || lasttype == 0){
				(pend)--; /* don't let the \n get into the title */
				type = lasttype;
				break;
				}
				/* statement continued on next line */
			go = STOP;
			rhsreturn = 'f';
			(pend)--;
			break;
		case ';':
			go = STOP;
			rhsreturn = ';';
			(pend)--;
			break;
      case 'e':
         go = STOP;
         rhsreturn = 'e';
         break;
		default:
			printf(MSGRHS(1));
			rhsreturn = ERR;
			goto done;

		} /* end of switch */
	} /* end of while */
if((addsub(f,op_stack,&osp,a,&nopyf,nopya))==ERR) {
	rhsreturn = ERR;
	goto done;
	}
npy = nopyf;
if(npy==0)
   npy=freqdefault;
*pend = '\0';
(pend)++;   /* Make pointer point to space after the last null. */
ipend=ipend;
done:
	//free_vector(ss,0);
	free_vector(a,0);
	free_vector(b,0);
	return(rhsreturn);
}
/****************************************************************************/
/* rhssyn(lasttype) -- rhs syntax checker detects two arithmetic operators in
/*                     succession.
/***************************************************************************/
short Chopper::rhssyn(short lt) {
if(lt=='+'|| lt == '-' || lt == '*' || lt == '/'){
	printf(MSGRHS(2));
	return(ERR);
	}
return(OK);
}
/****************************************************************************/
/* muldiv(a,op_stack,posp,b,pnopya,nopyb)                                                      */
/* this subroutine does a = a*b or a = a/b and returns 2 if top operator on */
/* stack is + or -; otherwise it does a = b and returns 1.                  */  
/****************************************************************************/
short Chopper::muldiv(float *a, char *op_stack, short *posp, float *b, 
	short *pnopya, short nopyb) {   

short i;
if(*pnopya == 0) *pnopya = nopyb;
else if(*pnopya != nopyb && nopyb != 0){
	printf(MSGRHS(3));
	return(ERR);
	}
if (op_stack[*posp] == '*')  {
   for (i = 0; i<Interval; i++){
	if(IsMissing(a[i]))
		a[i] = a[i];
	else if(IsMissing(b[i]))
		a[i] = b[i];
	else
		a[i] = a[i] * b[i];
	}
	(*posp)--;
	}

else if (op_stack[*posp] == '/') {
	for(i = 0; i<Interval; i++){
	if(IsMissing(a[i]))
	 	a[i] = a[i];
	else if(IsMissing(b[i]))
	 	a[i] = b[i];
      else if(b[i] != 0)
      a[i] = a[i] / b[i];
      }
	(*posp)--;
	}

   else {
   for(i = 0; i<Interval; ++i) 
      a[i] = b[i];
   }
return(OK);
}
/*******************************************************************/
/*   addsub(f,op_stack,posp,a,pnopyf,nopya)                        */
/* this is a routine to check if plus or minus on stack and operate*/
/*******************************************************************/

short Chopper::addsub(float *f, char *op_stack, short *posp, float *a, 
	short *pnopyf, short nopya) {

short i;

if(*pnopyf==0) *pnopyf = nopya;
else if (*pnopyf != nopya && nopya != 0){
	printf(MSGRHS(3));
	return(ERR);
	}
if (op_stack[*posp] == '+'){
	for (i = 0; i<Interval; i++){
		if(IsMissing(a[i]))
		 	f[i] = a[i];
		else if(IsMissing(f[i]))
		 	continue;
		else 
			f[i] += a[i];
		}
	(*posp)--;    
	}
else if (op_stack[*posp] == '-') {
	for(i = 0; i<Interval; i++){
		if(IsMissing(a[i]))
			f[i] = a[i];
		else if(IsMissing(f[i]))
		 	continue;
		else
			f[i] -= a[i];
		}
	(*posp)--;   
	}
else {
	for (i = 0; i<Interval; i++)
		f[i] = a[i];
	}       
return(OK);
}
/******************************************************/
/*  functions(f,pend)                                 */
/*  this is a subroutine to calculate the cum, exp,
      log functions, etc.
/*******************************************************/

short Chopper::functions(float *f, char *pend) {     

char err,s[90];

if ((err = chop(s)) != 'a'){
	printf(MSGRHS(5));
	return(ERR);
	}
pend = gstrcpy(pend,s);
(pend)--;

if (strcmp(s,"csum") == 0) err = csum(f,pend);
else if (strcmp(s,"cum") == 0) err = accum(f,pend);
else if (strcmp(s,"exp") == 0) err = expo(f,pend);
else if (strcmp(s,"log") == 0) err = logarithm(f,pend);
else if (strcmp(s,"sin") == 0) err = sine(f,pend);
else if (strcmp(s,"fabs") == 0) err = abso(f,pend);
else if (strcmp(s,"sq")  == 0) err = square(f,pend);
else if (strcmp(s,"sqrt") == 0) err = square_root(f,pend);
else if (strcmp(s,"pct") == 0) err = pctcmd(f,pend);
else if (strcmp(s,"pos") == 0) err = positive(f,pend);
else if (strcmp(s,"pow") == 0) err = power(f,pend);
else if (strcmp(s,"peak")== 0) err = peak(f,pend);
else if (strcmp(s,"rand")== 0) err = unirand(f);
else if (strcmp(s,"round")== 0) err = round(f,pend);
else if (strcmp(s,"ifpos") == 0)  err = ifpos(f,pend);
else {
	printf(MSGRHS(6), s);
   return(ERR);
	}
return(err);
}

/***********************************************************/
/*  csum(f,pend)                                      */
/*                                                         */
/*  This function calculates a sum of sectors of a given   */
/*    concept (such as exports), as specified by the group */
/*    syntax used in VAM.                                  */
/*                                                         */
/*  For example, the call                                  */
/*    @csum(out,1-10 (4-7) 13 15)                          */
/*  would include output for sectors 1 to 10, except for   */
/*  4 through 7, and then 13 and 15.                       */
/*                                                         */
/*  Processing the group definition requires use of the    */
/*    fill function.                                       */
/*                                                         */
/*                                                         */
/***********************************************************/

unsigned short ngp1, ngel, *grouper, *groups, *dgroup;

short Chopper::csum(float *f, char *pend) {

char s[50], concept[20], mnemonic[20];
short err,i,j,members[500];
float *term;

err = ERR;
term = 0;
if((term = vector(0,Interval+100)) == 0){
	printf("Out of memory in csum.\n");
	goto tidy;
	}
for(i=0;i<500;i++) members[i]=0;
for(i=0;i<Interval;i++) term[i]=0;
/* read the arguments to the function  */
if((chop(s)) != '(') goto error;
if((chop(concept)) != 'a') goto error;
if((chop(s)) != ',') goto error;
// fill will set members[i] to 1 if sector i is in the summation. 
fill(members);

for(i=1;i<500;i++) {
  	if(members[i]) {
		sprintf(mnemonic,"%s%d",concept,i);
		if((err=find(mnemonic,pend,term,1))<0) {
			//printf("Error reading series %s from bank.\n",mnemonic);
			//goto tidy;
			}
      else {
   		for(j=0;j<Interval;j++)
   			f[j]+=term[j];
         }
		}
	}
err = OK;
goto tidy;
error:
	printf("Syntax error in @csum(name,groupdefn)\n");
tidy:
	free_vector(term,0);
	return(err);
}
/* fill *******************************************************************/
/* The trick here is the inout variable.  It is initially set to 1, meaning
to include in the group all numbers specified.  If an '(' is encountered, it
switches to 0, and all elements encountered will be excluded from the group
until a ')' or '(' is encountered, which will switch it back to 1. ******/

short Chopper::fill(short members[]) {

short i, n, lastn, inout, paren,type,maxel,tipo,more=1;
char lasttype,err,s[20];

inout = 1;
paren = 0;
lasttype = 0;
err = 'n';
maxel = 0;

while(more){
	type = chop(s);
	if(type == 'f' && lasttype != ',') break;
	lasttype = type;

	switch(type){
		case 'n':
			n = atoi(s);
			members[n] = inout;
			lastn = n;
			if(n > maxel) maxel = n;
			break;
		case '-' :
			tipo = chop(s);
			if(tipo != 'n'){
				printf("\nA - must be followed by a number.");
				err = 'y';
				break;
				}
			n = atoi(s);
			for (i = lastn; i <= n; i++)
				members[i] = inout;
			if(n > maxel) maxel = n;
			break;
		case '(' :
			if(inout == 1) inout = 0;
			else inout = 1;
			paren++;
			break;
		case ')' :
			if(inout == 1) inout = 0;
			else inout = 1;
			paren--;
			if(paren<0) more=FALSE;  // catch right hand side paren ?
			break;
		case ',':
			break;
		case ':': /* use previous group */
			tipo = chop(s);
			if(tipo != 'n'){
				printf("\nA : must be followed by a number.");
				err = 'y';
				break;
				}
			n = atoi(s);
			for(i = grouper[n-1]; i < grouper[n]; i++){
				members[groups[i]] = inout;
				if(groups[i] > maxel) maxel = groups[i];
				}
			break;
		default :
			printf("\nUnrecognized element %s",s);
			err = 'y';
			break;
		}
	if(err == 'y') break;
	}
return(maxel);
}
/***********************************************************/
/*  accum(f,pend)                                      */
/*                                                         */
/* this subroutine calculates  @cum(output,input,spill)    */
/***********************************************************/

short Chopper::accum(float *f, char *pend) {

char rtn,s[40],s2[10],output[40];
short series_number,i,nopyf;
float *spill;
float cum = 0.;

spill = vector(0,Interval+100);
/* read the arguments to the function  */
if((chop(s)) != '(') goto error;
if((chop(output)) != 'a') goto error;
if((chop(s)) != ',') goto error;
if((rhs(f,pend)) != ',') goto error;
if((rhs(spill,pend)) != ')') goto error;

/* cumulate the input series  */ 	
for(i=0,cum=IsMissing(f[0])?0:f[0];i<Interval;i++)
   if(IsMissing(f[i]))
      cum *= (1. - spill[i]);
   else 
      f[i] = (cum = (1. - spill[i])*cum + f[i]);

npy = 1;
rtn=OK;
goto done;
error:
	printf(MSGRHS(7));
	rtn = ERR;
done:
	free_vector(spill,0);
return(rtn);
}	
/**************************************************************/
/*  peak(f,pend)                                              */
/* this subroutine calculates  @peak(output,input,decline)    */

short Chopper::peak(float *f, char *pend) {

char s[40],output[40];
short  series_number,i;
float decline, floor;

/* read the arguments to the function  */
if((chop(s)) != '(') goto error;
if((chop(output)) != 'a') goto error;
if((chop(s)) != ',') goto error;
if((rhs(f,pend)) != ',') return(ERR);
if((chop(s)) != 'n') goto error;
decline = atof(s); 
if ((chop(s)) != ')') goto error;

/* put a floor under declines in the input series  */ 	
for(i=1;i<Interval;i++){
	floor = (1. - decline)*f[i-1];
	if(fabs(floor) < .000001) floor = 0;
	if(f[i] < floor) f[i] = floor;
	}

//if((series_number = ws->addser(output,f))!=ERR){
//	if(building == 'y') cumlag(series_number);
//	return(OK);
//	}
//series_number=series_number;
error: printf(MSGRHS(8));
return(ERR);          
}	
/**************************************************************/
/* this subroutine calculates  @round(input,decplaces)        */
short Chopper::round(float *f, char *pend) {
char s[40];
short  decplaces,i;
float power,fraction,fi;
long li;

/* read the arguments to the function  */
if((chop(s)) != '(') goto error;
if((rhs(f,pend)) != ',') goto error;
if((chop(s)) != 'n') goto error;
decplaces = atoi(s); 
if ((chop(s)) != ')') goto error;

power = 1.;
i = 0;
while(i < decplaces){
	power *= 10.;
	i++;
	}
fraction = 1./power;

/* put a floor under declines in the input series  */ 	
for(i=0;i<Interval;i++){
	if(f[i] >= 0.) li = power*f[i] + .5;
	else li = power*f[i] - .5;
	fi = li;
	f[i] = fraction * fi;
	}
return(OK);
error: printf(MSGRHS(9),"round");
return(ERR);          
}	
/**************************************************************/
/*  expo(f,pend)                                          */
/* this function will compute the exponential and return f    */
/**************************************************************/
short Chopper::expo(float *f, char *pend) {
short i,err;
char s[40];


if ((err = chop(s)) != '(') goto error;
else {
	pend = gstrcpy(pend,s);
	(pend)--;
	}
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++){
	if(IsMissing(f[i]))
	 	continue;
	else f[i] = exp((double)f[i]);
	}
return(OK);

error:
	printf(MSGRHS(9),"@exp");
	return(err);
}
/**************************************************************/
/*  sine(f,pend)                                          */
/* this function will compute the sine and return f           */
/**************************************************************/
short Chopper::sine(float *f, char *pend) {
short i,err;
char s[40];

if ((err = chop(s)) != '(') goto error;
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++)
	f[i] = sin((double)f[i]);
return(OK);

error:
	printf(MSGRHS(9),"@sin");
	return(err);
}
/***************************************************************************/
/*  ifpos(f,pend)                                                      */
/* this function has the value of 1 where the argument is +, else 0.       */
/***************************************************************************/
short Chopper::ifpos(float *f, char *pend) {
short i,err;
char s[40];

if ((err = chop(s)) != '(') goto error;
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++)
	f[i] = (f[i] > 0) ?  1. : 0 ;
return(OK);

error:
	printf(MSGRHS(9),"@ifpos");
	return(err);
}
/**************************************************************/
/*  abso(f,pend)                                          */
/* this function will compute the absolute value and return f       */
/**************************************************************/
short Chopper::abso(float *f, char *pend) {

short i,err;
char s[40];

if ((err = chop(s)) != '(') goto error;
else {
	pend = gstrcpy(pend,s);
	(pend)--;
	}
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++){
	if(IsMissing(f[i]))
	 	continue;
	f[i] = fabs(f[i]);
	}
return(OK);

error:
	printf(MSGRHS(9),"@fabs");
	return(err);
}
/**********************************************************************/
/*   logarithm(f,pend)                                            */
/* this function computes the log                                     */
/**********************************************************************/

short Chopper::logarithm(float *f, char *pend) {
short i,err;
char s[40];


if ((err = chop(s)) != '(')
		goto error;
else {
	pend = gstrcpy(pend,s);
	(pend)--;
	}
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++){
	if(f[i]>0) f[i] = log((double)f[i]);
	else f[i] = MISSING;
	}
return(OK);

error:
	printf(MSGRHS(9),"@log");
	return(err);
}
//===========================================================================
/* this function will compute the square */
short Chopper::square(float *f, char *pend) {
short i,err;
char s[40];

if ((err = chop(s)) != '(') goto error;
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++){
	if(IsMissing(f[i]))
	 	continue;
	f[i] = f[i]*f[i];
	}
return(OK);

error:
	printf(MSGRHS(9),"@sq");
	return(err);
}
//===========================================================================
short Chopper::square_root(float *f, char *pend) {
short i,err;
char s[40];

if ((err = chop(s)) != '(') goto error;
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++){
	if(f[i] < 0.0) f[i] = 0.0;
	f[i] = sqrt(f[i]);
	}
return(OK);

error:
	printf(MSGRHS(9),"@sqrt");
	return(err);
}
/***********************************************************/
/*  pctcmd(f,pend)                                      */
/*                                                         */
/* calculates the percentage change  @pct(level)    */
/* That is : f = (level - level[1]) / level[1] * 100.0
/***********************************************************/

short Chopper::pctcmd(float *f, char *pend) {
int i,err;
char s[40];

if ((err = chop(s)) != '(') goto error;
if ((err = rhs(f,pend))  != ')') goto error;

for(i = Interval - 1;i>0;i--) {
   if(f[i]<=-0.0000009 && f[i] >= -0.0000011)
      f[i] = -0.000001;
   else
      f[i] = (fabs(f[i-1])==0 ||(f[i-1] <= -.0000009 && f[i-1] >= -.0000011))?
   -.000001 : ((f[i] - f[i-1])/f[i-1] * 100.);
}
f[0] = -0.000001;
return(OK);

error:
printf(MSGRHS(9),"@pct");
return(err);
}

/**************************************************************/
/* this function will zero out negative items */
short Chopper::positive(float *f, char *pend) {
short i,err;
char s[40];

if ((err = chop(s)) != '(') goto error;
if ((err = rhs(f,pend))  != ')') goto error;

for(i = 0;i<Interval;i++){
	if(IsMissing(f[i]))
	 	continue;
	if(f[i] < 0 ) f[i] = 0;
	}
return(OK);

error:
	printf(MSGRHS(9),"@pos");
	return(err);
}
/************************************************************************/
/*  power(series,power)                                                 */
/*  this function raises each observation of the series to any real     */
/*  number power.                                                       */
/************************************************************************/
short Chopper::power(float *f, char *pend) {
double pao;
char s[40];
short i,err;
float sign;
double x;

if((chop(s)) != '(') goto error;
if((rhs(f,pend)) != ',') return(ERR);
sign = 1.;
if((err = chop(s)) == '-'){
	sign = -1.;
	if((err = chop(s)) != 'n') goto error;
	}
if(err != 'n') goto error;
pao = sign*atof(s);
if((chop(s)) != ')') goto error;

for(i = 0; i < Interval; i++){
	if(IsMissing(f[i]))
	 	continue;
	x = f[i];
	f[i] = pow(x,pao);
	}
return(OK);

error:
	printf(MSGRHS(9),"@pow");
	return(ERR);
}
/************************************************************************/
/*  unirand                                                            */
/*  this function will make a vector of random numbers, each uniformly  */
/*  distributed over the interval 0 to 1.                               */
/************************************************************************/
short Chopper::unirand(float *f) {
char s[40];
short i;
float x;

if((chop(s)) != '(') goto error;
if((chop(s)) != ')') goto error;

#ifdef __DOS__
randomize();
#endif
for(i = 0; i < Interval; i++){
	x = rand();
	f[i] = x/32768;
	}
npy = 0;
return(OK);

error:
	cprintf(MSGRHS(9),"@rand");
	return(ERR);
}

//=======================================================================
/* FIND -- This version of find has been rewritten to look first in 
   the G bank (dyme.bnk) assigned for the simulation, and then in 
   the Vam file, for the series in the expression.  If the name
   of the series is "fixval", then it is taken from the current 
   body of the fix.
*/
	
// If quiet is true, find doesn't complain about not finding series
short Chopper::find(char *nam, char *pend, float *ss, short quiet) {

short err,i,j,bankno,ibank,year,period,freq;
short gap,nobs_ab;
float val,Oliver;
char *pnam,cnpy,banknum[3],vfixname[20];
GDate Assigned_BaseDate,bd;
short Found=0;

for( i = 0; i < Interval;i++)
	ss[i] = 0;

pnam = nam;

/*
This section is the key to how the equation fixer works.              
Finally, it First, it checks to see if the name of the variable is
"fixval" in which case it returns the time series of the body of the
fix.  Next it looks in the array of TSeries variables that have been
loaded into memory.  Then it looks to see if this data item is one of
the vectors of the model.  If so, it retrieves the current element,
and gets the historical elements from the Vam file. 
*/

if(strcmp(pnam,"fixval")==0) {
   // Are we doing a macro or a vector fix?
   if(MacFixNumber >= 0) {
      err=mfbank.GetFix(MacFixNumber,ss);
      if(err>=0) {
         Found = 3;
         goto foundOK;
         }
      }
   else if(VecFixNumber >= 0) {
      sprintf(vfixname,"fix%d",VecFixNumber+1);
      err=vf[0].getser(vfixname,ss,Interval);
      if(err>=0) {
         Found = 2;
         goto foundOK;
         }
      }
   else {
      cprintf("Error using fixval.  No fix!\n\r");
      return -1;
      }
   }
if((err=GetTseries(pnam,ss))>=0) {
	Found=1;  // Found variable in Tseries array
	goto foundOK;
	}
if((err=vf[0].getser(pnam,ss,Interval))>=0) {  // Get history first.
	Found=2;  // Found vector item
	goto foundOK;
	}

if(Found==0)
   goto error;

foundOK:

if(Found!=1) {
   // Base Date of series Just Found:
   if(Found==2)
      bd = GDate(vf[0].GetBaseYr(),vf[0].Getstper(),1 );
   else if(Found==3)
      bd = GDate(mfbank.GetBaseYr(),mfbank.Getstper(),1);
   Realign(ss,bd,BaseDate);  // BaseDate is GBank base date.
   // Now retrieve current observation from model memory, if a vector.
   if(Found == 2)
      if((err=GetVecCurObs(pnam,Oliver))>=0)
         ss[Interval-1] = Oliver;  // if loaded, use it
   }

err=check_lag(ss,pend);

npy = 1; // Currently, Interdyme is annual
return (OK);

/* If not there, make sure series is 0.0, or missing. */
error:
if(!quiet)
   cprintf("%s can\'t be found.\n\r",nam);
for( i = 0; i < Interval;i++)
	ss[i] = (UseMissing=='y')?MISSING:0.0;
err=err;
return(ERR);
}
//===============================================================
/* Realign -- This is now programmed to bring the series or
   expression back aligned so the zero point is at the base year,
   starting period, but at whatever native frequency the series is
   in.  Be sure to convert BaseDate to proper frequency before 
   aligning!

   Note: In this equation fixer version for Interdyme, if the G
   bank BaseDate and the Vam file base year are different, we
   use the GBank date.  
*/
short Chopper::Realign(float *f, GDate& bd, GDate& BaseDate) {
short shift,i, m;
GDate gd;
gd = BaseDate;
gd.freq = bd.freq;
if(bd == gd)
   return 0;
shift = gd - bd;  // date arithmetic
if(shift > 0) {
   for(i=0;i<Interval;i++) {
      if(i+shift > Interval)
         f[i] = UseMissing=='y'?MISSING:0.0;
      else
         f[i] = f[i+shift];
      }
   }
else {
   for(i=0;i<Interval;i++) {
      m = Interval - i - 1;
      if( m+shift >= 0) 
         f[m] = f[m+shift];
      else f[m] = UseMissing=='y'?MISSING:0.0;
      }
   }
return shift;
}
//=============================================================================
/* check_lag does lagged values, or constant dates.  Lagged values
	 are indicated by 'series[1]' for a one period lag, etc.
	 Constant dates are indicated by something such as 'series{77.1}'
	 It is important that this is included as part of the variable
	 name.
*/

short Chopper::check_lag(float *ss, char* pend) {
char s[32];
short type, lag, i, j;
float cons;
GDate date;

lag = 0;

if((type = chop(s)) == '[')  {
	pend = gstrcpy(pend,s);
	(pend)--;
	if(chop(s) == 'n')  {
		lag = atoi(s);
		/* lag the series */
		sprintf(s,"%d",lag);
		pend = gstrcpy(pend,s);
		(pend)--;

		if(lag > 0){
			/* lag the series */
			for (i=lag; i<Interval; i++) {
				j = Interval + lag - i - 1;
				ss[j] = ss[j-lag];
				}
			for (i=0; i<lag;i++) 
  				ss[i] = (UseMissing == 'n') ? 0.0 : MISSING;
			}
		else if(lag < 0) {
			/* advance the series */
			for(i = 0; i < Interval + lag; i++)
				ss[i] = ss[i-lag];
			for(i = Interval + lag; i< Interval; i++)
				ss[i] = (UseMissing == 'n') ? 0.0 : MISSING;
			}
		if (chop(s) != ']')  {
			cprintf(MSGG(8));
			return(ERR);
			}
		else  {
			pend = gstrcpy(pend,s);
			(pend)--;
			}
		}
	else {
		cprintf(MSGG(13));
		return(ERR);
		}
	}
else if (type == '{')    {
	pend = gstrcpy(pend,s);
	pend--;
	if(chop(s) == 'n')   {
		pend = gstrcpy(pend,s);
		pend--;
		date = s;	
		j = date.ObNo(BaseDate);
		cons = ss[j];
		for(i=0; i<Interval; i++)
			ss[i] = cons;
		}
	else  {
		printf(MSGG(9));
		return(ERR);
		}
	if(chop(s) != '}') {
		printf(MSGG(10));
		return(ERR);
		}
	else {
		gstrcpy(pend,s);
		pend--;
		}
	}
else unchop();

return(lag);
}  /* end check_lag */
//========================================================================
short GetTseries(char *name, float ss[]) {

short i,j,ns_ws;
char chkname[40];
ns_ws = gb.Getnseries();  // This is the model GBank (global).
for(i = 0; i < ns_ws; i++) {
	if(Tsptr[i] != 0) 
      if((strcmp(name,Tsptr[i]->tsname))==0) {
         for(j=0;j<Interval;j++)
            ss[j] = Tsptr[i]->ts[j];
         return Tsptr[i]->seq;
         }
   }
return -1;
}
   
//========================================================================
/* Need to expand to also handle matrices */
short GetVecCurObs(char *name, float& x) {
short i,j,k,sec,nr;
char vname[20];

// Get vector name and sector.
sec = breakname(name,vname);

// Walk through vectors in model
for(k=0;k<matcount;k++) {
   if(strcmp(mats[k].name,vname)==0) {
      nr = mats[k].rows;
      if(sec <= 0 || sec > nr) {
         cprintf("Error: Bad sector number: %s in equation fix\n\r",name);
         dymetap();
         return -1;
         }
      if(mats[k].loaded!='y') {
         cprintf("Error: Matrix or Vector: %s is not loaded in equation fix\r\n",vname);
         cprintf("  Make sure to declare this in your model if you want to use it.\n\r");
         dymetap();
         return -1;
         }
      x = mats[k].vptr[sec-1];
      return 0;
      }
   }
return -2;  // not found
}
#endif
