/* DYMESYS.H -- This is the include file for the dyme system variables
    and files, that the average model builder shouldn't need to change.
    Functionality that is necessary can be indicated by #defining various
    tokens such as "INCL_MATRIX", etc.
*/

#define DYME 1
#if !defined(GLOBAL)
#define GLOBAL extern
#define EXTERNAL
#endif

const float InterDymeVersion = 2.52;
const short MAXVAMFILES = 10;

#include "features.h"  // Tells which features of Interdyme to include.


#if defined(OS2COMPILE)
    #if defined max
        #undef max
    #endif
    #if defined min
        #undef min
    #endif
#endif

#include <stdio.h>  // for printf
#include <stdlib.h> // for atoi, exit
#include <string.h> // for strcpy
#include <sys\types.h>
#include <sys\stat.h> // to test for file existence.
#include <iostream.h> // for cout, cerr
#include <conio.h>  // for getch
#include <float.h>  // for _control87()
#include <math.h>   // for fabs()
#include <ctype.h>
#include <setjmp.h>  // for jumps in pmatrix.cpp
#include <signal.h>
#include <time.h>  // for time functions
#include <new.h>   // set_new_handler


#if !defined(OS2COMPILE)
#include <fcntl.h>  // for _fmode
#include <dir.h>  // for findfirst()
#include <dos.h>   // ctrl_break
#include <alloc.h>  // for coreleft
#endif

#ifdef INCL_MEMCHECK
#include <memcheck.h>
#endif 

// Matrix and Vector (Bump) functionality:
#if defined(INCL_MATRIX)
#include "matrix.h"      // class definitions of Vector, Matrix, Pmatrix
#endif

#if defined(INCL_MACRO)
#include "tseries.h"     // class definition of Tseries
#include "macfxbnk.h"    // class definition of MacFixBank
#endif

#if defined(INCL_GROUPS)
#include "groups.h"      // class definition of Groups
#endif

#include "databank.h"
#include "vamfile.h"     // class definition of VamFile

#if defined(INCL_FIX)
#include "fixbank.h"     // class definition of FixBank
#endif


#if defined(INCL_EQUATION)
#include "equation.h"
#endif

#if defined(INCL_PADS)
#include "pads.h"
#endif

#if defined(INCL_EQFIX)
#include "gdate.h"
#endif

#if defined(INCL_RESECTOR)
#include "resector.h"
#endif

#if !defined(EXTERNAL)
#include "message.inc"
#include "messinit.inc"
#else
#include "message.ext"
#endif

#include "message.h"     // class definition of Message
#include "chopper.h"

#if defined(INCL_SCREEN)
#include "cxldef.h"
#include "cxlwin.h"
#include "cxlvid.h"
#endif


#if !defined(__BCB__)
#if !defined(EXTERNAL)
extern unsigned _stklen = 64000; 
extern int _fmode = O_TEXT;
#else
extern unsigned _stklen;
extern int _fmode;
#endif
#endif

#include "idproto.h"
// Global variables, that may be needed in all Interdyme models, depending
//      on which functionalities are included:
#include "dyme.inc"
#include "constant.h"  // TRUE,FALSE,ERR,ESC, etc. (also 'MAX' variables)

GLOBAL void spin();
GLOBAL short shiftback(short t);
