// FEATURES.H -- Specify which features of Interdyme to include.

// Note that by commenting out one or more of the following INCL_
//   definitions, you tell dyme that you do not need that capability:
// Tell that we are using Borland C++ Builder (BCB)
#define __BCB__
// Tell compiler we are Linux
//#define __LINUX__
//Tell compiler we are in DOS
//#define __DOS__
// Use matrix and vector capabilities of Interdyme:
#define INCL_MATRIX
// Use macro variable capabilities of Interdyme.  Of course, this is
//    also required for macro fixes.
#define INCL_MACRO
// Use fixes capabilities of Interdyme.  Note that if you use fixes, you
//   also need groups and matrices. However, groups can be used alone.
#define INCL_FIX
// Use groups capabilities of Interdyme:
#define INCL_GROUPS
// Use fixed coefficient Equation capabilities of Interdyme:
#define INCL_EQUATION
// CXL Screen Library (for opening configuration screen (optional):
//   Comment this out if you are using the DOS Extender:
//#define INCL_SCREEN
// Seidel calculation:
#define INCL_SEIDEL
// PADS Consumption Equations
#define INCL_PADS
// Use IVector class instead of ReadTriang, etc.
#define INCL_IVECTOR
// Equation type fixes
#define INCL_EQFIX
// ReSector aggregation class
//#define INCL_RESECTOR
// Enable use of Dirfor class.
//#define INCL_DIRFOR
// Enable compilation for OS/2.
//#define OS2COMPILE
// Enable use of MemCheck Memory Checker
//#define INCL_MEMCHECK
// Enable use of coreleft() and farcoreleft()
//#define INCL_CORELEFT
// Enable use of ctrl_brk()
#define CTRL_BREAK
// Enable use of control87(), status87(), arith87(), etc.
#define CONTROL87

#ifdef __BCB__
#undef INCL_CORELEFT
#undef CTRL_BREAK
#undef CONTROL87
#endif

// Note that these #defines affect conditional compiles in DYMESYS.H.
