//  GBANK.H -- Class declarations for G data bank objects.
//#define OS2COMPILE

#if !defined(GBANK_H)
#define GBANK_H 1

#include "databank.h"

// If we don't do this, fixbank and gbank cause multiple declarations.
#if !defined(BNKHEADER)
#define BNKHEADER 1
struct bnkHeader {
	short jahra, stper, nobs;
	char bnktitle[80];
	short ReadIn(FILE *fp);
	short WriteOut(FILE *fp);
	};
#endif
class GBank : public DataBank    {
// GBank: Object to handle transactions with simple G file.

protected:
	unsigned short ncin;
	char *names;
	unsigned short *indx;
   char status;

public:
	enum {NCMAX=30000, NSMAX=3000};
	char cnpy;  // public, changed by each getser call.
	// constructors
	GBank(void); // default constructor
	// copy constructor:
	GBank(GBank&);
	GBank(const char *);  // Open file name, initialize members.
	GBank(const char *rootname, const char *status,
		short BaseYr=1965, short nobserv=200, short stper=1);
	virtual char *Setbnktitle(const char *s);
	// destructor
	~GBank();

	short AssignBank(const char *rootname);  // Assign bank, already constructed
						// with default constructor.
	// index I-O
	short windex(void);
	short rindex(void);

	// Put and Get
	short addser(char *nam, float *f, char wrindex_flag='y', short SeriesLength=-1);

	short getser(char *nam, float *f, short SeriesLength);
	virtual short getser(char *nam, float *f);
	virtual short ListNames(FILE*,char*,short wide=1);

	short findname(char *gname);
   char* GetName(short loc,char *gname);

	// inline functions
	short Getnobs(void)   {return nobs;};
	short Getnseries(void) {return nseries;};
	// Special for Haver Analytics FAME format: (IBM project)
	short dumpall(FILE *dmp,short startyr,short lastyr,short decs);
	short flush(void);

};


#endif // end GBANK_H class definitions



