/* IDPROTO.H -- Prototypes necessary for Interdyme.  These were taken
	out of dyme.h and put here. 

	WARNING!! If you want to be able to use routines that take matrices
	and vectors, you must have #define INCL_MATRIX before dymesys.h,
	so that these .h files will be included.
*/


void dymetap();  // ask to store data


// prototypes for DYMUTIL.CPP
#ifdef INCL_IVECTOR
short AggVec(Vector& a, Vector& b, IVector& iag);
short SplitVec(Vector& a, Vector& b, Vector& c, IVector& iag);
#endif
void arith(char *pgm,short where=-1);
short breakname(char *nam, char *vnam);
int getint(int& n, FILE *fp, char *s, short& j);
inline short getint(short& nn, FILE *fp, char *s, short& j){
   short hold; int n;
   n = (int)nn;
   hold = (short)getint(n, (FILE*)fp, (char*)s, (short&) j);
   nn = (short)n;
   return hold;
   }
//	return (short)getint((int&) n, (FILE*)fp, (char*)s, (short&) j);}
inline int getint(int& n, FILE *fp, char *s, int& jj){
   int hold; short j;
   j = (short)jj;
   hold = getint((int&)n, (FILE*)fp, (char*)s, j);
   jj = (int)j;
   return hold;
   }
//	return (int)getint((int&) n, (FILE*)fp, (char*)s, (short&) j);}

   
short getname(char *field, FILE *fp, char *s, short& j);
void tap();
short getclopt(char opt, char *s, short argc, char **argvec);
short getopt(FILE *fp, char* line, short maxchar=20);
float interp(short n, short *dates, float *values);
short matchwild(char *name, char *wildcard);
char *sgets(char *text, short width, char *s);
char *sgetint(char *text, short width, short *num);
char *sgetint(char *text, short width, short &num);
char *sgetfl(char *text, short width, float *x);
char *sgetfl(char *text, short width, float &x);
short getfloat(float& f, FILE *fp, char *s, short& j);
short getint(short& f, FILE *fp, char *s, short& j);
inline short max(short a, short b) { return (a>b)?a:b;}
inline short min(short a, short b) { return (a<b)?a:b;}
long MemoryLeft(void);
float safelog(float x, char* text=0);
float safepow(float x, float y, char* text=0);
float safesqrt(float x, char* text=0);
int _matherr (struct exception *a);


// prototypes for IDRUN.CPP
short CheckDeclar(short silence);
short load(short t);
short store(short t);
double rdscale(float *v1, short n, short *group, float control,
   short ScaleNegatives=1);
// Alternate version...
double rdscale(Vector& v1, short n, short *group, float control,
   short ScaleNegatives=1);
// Mike Field 
double pscale(Vector &vec, short n, short *group, float control);


#if defined(INCL_MATRIX)
double update(Vector&, Matrix&);
void  colnorm(Matrix& m, Vector& scalefactors);
void  rowscale(Vector& v, Matrix& m, char skipdiag = 'n');
void  colnorm(Pmatrix& pm, Vector& scalefactors);
void  rowscale(Vector& v, Pmatrix& pm, char skipdiag = 'n');
short lastdata(void);
void  rowctrl(Vector& v, Matrix& m, char skipdiag='n');
#endif

// for DYMSTART.CPP
short configure(void);
short InitMat(VamFile&);
short ReadTriang(void);
short ReadPTriang(void);
short ReadOutFix(void);
void depad(char *s);
void TackExt(char *filename, char *ext);

#if defined(INCL_MACRO)
// heart.cpp
void tserin();
void uptseries();

// for TSERIES.CPP
short assignbank(char *gbank);
short rindex(FILE *fp, char **nam, short *dat);
short findname(char *nam);
short fixreader(char *filename);
void modify(short seq,float depend,short eqType);
double cum(Tseries& y, float x, float s);
double peak(Tseries& y, float x, float s);
double pct(Tseries& y);
double pos(float x);
double sq(float x);
void storets(void);
void upets(void);
int follow(Tseries& a, Tseries& b, int t);

// CALLALL.CPP
void callall();
#endif

/* from Numerical Recipes */
float *vector(short nl, short nh);
double *dvector(short nl, short nh);
float **matrix(short nrl, short nrh, short ncl, short nch);
double **dmatrix(short nrl, short nrh, short ncl, short nch);
void free_vector(float *v, short nl);
void free_dvector(double *v, short nl);
void free_matrix(float **m, short nrl, short nrh, short ncl);
void free_dmatrix(double **m, short nrl, short nrh, short ncl);
short *ivector(short nl, short nh);
void free_ivector(short *v, short nl);

/* For Optimization; in maxi.cpp */
int	  coefdim(void);
void  coefgen(void);
bool  coefread(void);
bool  coefwrite();
int   solution(int k);
int   maxsolve();
float normal(void);
float ran0(void);

