/*     Class declarations and Function definitions for
								  BUMP 2.0
		  the Beginners Understandable Matrix Package
							for Borland C++
				 as modified for use in 
						INTERDYME
*/
#include "dymesys.h"
#include "user.h"

//#define DBG_UNLOAD
///////////////// The VORM member functions  /////////////////////////

void vorm::SetLastData(short date)
{
	mats[seq].LastDat = date;
	LastDat = date;
	}
short vorm::LastData(void)
{
	return(LastDat);
	}


///////////////// The Vector member functions  /////////////////////////

Vector::Vector(short anr, short anc, char atemp, short afr, short afc)
{
	short i;
	if(anr != 1 && anc != 1){
		cout << "Either the number of rows or the number of columns must be 1.\n";
		return;
		}
	which = vcount++;
	name=NULL;
	if(which<0 || which > 1000) {
		i=i;      
		}
	seq=-1;  // -1 indicates no position assigned.
	nr = anr;
	nc = anc;
	temp = atemp;
	if(temp=='y' || seq == -1)
		DymeLoaded='n';
	fr = afr;
	fc = afc;
	lr = fr + nr - 1;
	lc = fc + nc - 1;
	nelem = nr + nc - 1;
	if(nc == 1) first = fr;
	else first = fc;
	if(nelem < 0 || nelem > 16000){
		cout << nelem << "is an illegal number of elements for a Vector.\n";
		return;
		}
	if(nelem == 0)
		v = 0;
	else if((v = new float[nelem]) == 0)
		cout << "Out of memory.\n";
	}
//=======================================================================
Vector::Vector(Vector& a)
{
	short i,j;

	//which = a.which; // for copy constructor, which shouldn't change
	which = vcount++;
	if(which<0 || which > 1000) {
		i=j;
		j=i;
		}
	nr = a.nr;
	nc = a.nc;
	temp = a.temp;
	if(temp=='y' || seq==-1)
		DymeLoaded='n';
	seq = a.seq;
	fr = a.fr;
	fc = a.fc;
	lr = a.lr;
	lc = a.lc;
	first = a.first;
	nelem = a.nelem;
	if(a.name) {
		name=new char[strlen(a.name)+1];
		strcpy(name,a.name);
		}
	else name=NULL;
	/* Before the "operator " functions return, they must "destroy" the Temp
	vector they created.  But since many are returning Temp, C++ calls this
	function to make a copy of Temp.  That call is implicit; the programmer
	does not explicitly do it.  After that call, the destructor is called,
	also implicitly, to destroy the original Temp.  This copy will then be
	returned.  The following device detects that the vector being copied is a
	temporary vector doomed to immediate destruction, so it just captures the
	v array as its own and sets a.v = 0, so that the destructor won't hurt
	it.  */

	if(a.temp == 'y'){
		v = a.v;
		a.v = 0;
		}
	else{
		if((v = new float[nelem]) == 0){
			cout << "Out of memory trying to create Vector" << which <<".\n";
			exit(1);
			}
		for(i = 0; i < nelem; i++)
			v[i] = a.v[i];
		}
	}
Vector::Vector()
{
	short i;
	which = vcount++;
	if(which<0 || which > 1000) {
		i=i;
		}
	seq=-1;  // -1 indicates no position assigned.
	DymeLoaded='n';
	nr = 0;
	nc = 0;
	temp = 'n';
	fr = 0;
	fc = 0;
	lr = 0;
	lc = 0;
	first = 0;
	nelem = 0;
	v = 0;
	name=NULL;
	}
Vector::~Vector()
{
	int abominable, fildigrious;
	if(v != 0)
		delete v;
	v = 0;
	#ifdef DBG_DESTRUCT
	printf(" Calling destructor for Vector.  temp = %c\r\n",
		temp);
	if(which<0 || which > 1000)
		abominable=fildigrious;
	printf("    which = %d  seq = %d\r\n", which,seq);
	//if(name)
	//   printf(" name is %s\r\n", name);
	#endif
	#ifdef INCL_MATRIX
	if(DymeLoaded=='y' && which >= 0 && which < highwater) {
		#ifdef DBG_UNLOAD
		fprintf(chk,"Calling unload() from Vector destructor. Vector seq=%d\n",
			seq);
		fprintf(chk,"which=%d \n",which);
		#endif
		unload();  // turn off loaded flag in mats[] array.
		}
	#endif
	}
// Free heap memory
void Vector::freeh()
{
	if(v != 0) delete v;
	v = 0;
	}
short Vector::ReadA(char *filename)
{
	FILE *fp;
	short i,j;
	char s[241];

	if((fp = fopen(filename,"rt")) == 0){
		cerr << "Cannot open " << filename << ".\n";
		return(ERR);
		}
	fgets(s,240,fp);
	j = 0;
	for(i = 0; i < nelem; i++){
		if(getfloat(v[i],fp,s,j) == ERR){
			cerr << "Out of data in " << filename << ".\n";
			break;
			}
		}
	fclose(fp);
	return(OK);
	}
short Vector::First(void)
{
	return(first);
	}
void Vector::Display(char *title,short width, short decimalPlaces)
{
	short i, nperline;
	char fmt[20];

	if(strlen(title) > 0) printf("\n%s", title);

	nperline = 76/(width +1);
	sprintf(fmt," %s%d.%df", "%",width,decimalPlaces);

	for(i = 0;i<nelem;i++){
		if(i % nperline == 0) printf("\n%3d",i+fr+fc-1);
		printf(fmt,v[i]);
		}
	}
void Vector::Display(FILE* fp,char *title,short width, short decimalPlaces,
	short pagewidth)
{
	short i, nperline;
	char fmt[20];

	if(strlen(title) > 0) fprintf(fp,"\n%s", title);

	nperline = pagewidth/(width +1);
	sprintf(fmt," %s%d.%df", "%",width,decimalPlaces);

	for(i = 0;i<nelem;i++){
		if(i % nperline == 0) fprintf(fp,"\n%3d",i+fr+fc-1);
		fprintf(fp,fmt,v[i]);
		}
	}
void Vector::set(float value){
	short i;
	for(i = 0; i < nelem; i++)
		v[i] = value;
	}
void Matrix::set(float value){
	short i,j;
	for(i = fr; i <= lr; i++){
		for(j = fc; j <= lc; j++)
			m[i][j] = value;
		}
	}

void Vector::resize(int nra, int nca, int fra, int fca)
{
	int i;
	if(v != 0){printf("Cannot resize a Vector with content.\n"); return;}
	nr = nra;
	nc = nca;
	fr = fra;
	fc = fca;
	lr = fr+nr-1;
	lc = fc+nc-1;
	first = 0;
	nelem = max(nr,nc);
	if((v = new float[nelem]) == 0){
		cout << "Out of memory trying to resize Vector" << which <<".\n";
		exit(1);
		}
	for(i = 0; i < nelem; i++)
		v[i] = 0.;
	}

Vector& Vector::operator = (const Vector& a)
{
	short i;
	short s = (nelem < a.nelem) ? nelem : a.nelem;
	which = vcount++;
	for(i = 0; i < s; i++){
		v[i] = a.v[i];
		}
	a.freet();
	return(*this);
	}
Vector Vector::operator ~ () // Transposition
{
	short i;
	Vector Temp(nc,nr,'y',fc,fr);
	for(i = 0; i < nelem; i++)
		Temp.v[i] = v[i];
	return(Temp);
	}
float& Vector::operator [](const short i)
{
	if(v==0){
		cerr << "Error: Reference to a deleted Vector.\n";
		exit(1);
		}
	if(nc == 1){
		if (fr > i || lr < i){
			cerr << "Illegal Vector index: " << i << "\n";
			exit(1);
			}
		return(v[i - fr]);
		}
	else{
		if (fc > i || lc < i){
			cerr << "illegal Vector index: " << i << "\n";
			exit(1);
			}
		return(v[i - fc]);
		}
	}
// The A(i,j) operator gives a completely range-checked element.
float& Matrix::operator ()(short i, short j)
{
	if(m==0){
		cerr << "Error: Reference to a deleted Matrix.\n";
		exit(1);
		}

	if(i < fr || i > lr ){
		cerr << "illegal Matrix row index: " << i << "." << "\n";
		cerr << "matix id number" << which << "." << "\n";
		exit(1);
		}
	if(j < fc || j > lc) {
		cerr << "illegal Matrix column index: " << j << "." << "\n";
		cerr << "matix id number" << which << "." << "\n";
		exit(1);
		}

	return(m[i][j]);
	}

Vector Vector::operator - (const Vector &a)
{
	short i;
	if(fr != a.fr || lr != a.lr){
		cout << "Vector dimensions do not match in + operator.\n";
		}

	Vector Temp(nr,nc,'y');
	for(i = 0; i < nelem; i++)
		Temp.v[i] = v[i] - a.v[i];
	freet();
	return (Temp);
	}
float Vector::sum(short first, short last)
{
	double summa;
	float suma;
	short i;

	summa = 0;
	if(first==0 && last==0) { // default
		for(i=0;i < nelem; i++)
			summa += v[i];
		}
	else {  // first and last refer to fr,lr,fc,lc, etc.
		if(nr==1) { // row vector
			if(first<fc || last > lc) {
				printf("Illegal column indexes in Vector sum() function. %d,%d\n",
					first,last);
				return 0.;
				}
			for(i=first;i<=last;i++)
				summa += v[i-fc];
			}
		else {     // column vector
			if(first<fr || last > lr) {
				printf("Illegal row indexes in Vector sum() function.  %d,%d\n",
					first,last);
				return 0.;
				}
			for(i=first;i<=last;i++)
				summa += v[i-fr];
			}
		}
	suma = summa;
	return(suma);
	}
float Vector::csum(char *Group)
{
	double summa;
	float suma;
	short i;
	Chopper ch;  // needs chopper.h
	short shift=0, members[500];
	for(i=0;i<500;i++)
		members[i]=0;

	ch.SetSource(Group);
	ch.fills(members,shift);
	summa = 0;

	for(i=fr;i<=lr;i++) 
		if(members[i])
			summa += v[i+shift-fr];
	suma = summa;
	return(suma);
}
//////////////// Friends of Vector (only) /////////////////////////
/* operator + and operator - are written differently to illustrate
	the two methods.
*/
Vector operator + (const Vector &a, const Vector &b)
{
	short i;
	if(b.fr != a.fr || b.lr != a.lr){
		cout << "Vector dimensions do not match in + operator.\n";
		}

	Vector Temp(a.nr,a.nc,'y');
	for(i = 0; i < a.nelem; i++)
		Temp.v[i] = a.v[i] + b.v[i];
	a.freet();
	b.freet();
	return (Temp);
	}
Vector operator * (const float a, const Vector &b)
{
	short i;
	
	Vector Temp(b.nr,b.nc,'y');
	for(i = 0; i < b.nelem; i++)
		Temp.v[i] = a * b.v[i];
	b.freet();
	return (Temp);
	}
Vector operator / (const Vector &a, const float b)
{
	short i;
	float recip;
	
	Vector Temp(a.nr,a.nc,'y');
	recip = 0;
	if(b == 0)	printf("Division by zero in Vector operator /.\n");
	else recip = 1./b;
	for(i = 0; i < a.nelem; i++)
		Temp.v[i] = a.v[i]*recip;

	a.freet();
	return (Temp);
	}
Vector ebediv (const Vector &a, const Vector &b)
{
	short i;
	Vector Temp(a.nr,a.nc,'y');
	for(i = 0; i< a.nelem; i++){
		if(fabs(b.v[i]) > 0.0000001) Temp.v[i] = a.v[i]/b.v[i];
		else Temp.v[i] = a.v[i];
		}
	return (Temp);
	}
Matrix ebediv (const Matrix &a, const Matrix &b)
{
	short i,j,nc,nr;
	nc = a.columns();
	nr = a.rows();
	Matrix Temp(nr,nc,'y');
	for(i = 1; i<= nr; i++){
		for(j = 1; j <= nc; j++)
		if(fabs(b(i,j) ) > 0.0000001)
			Temp[i][j] = a(i,j)/b(i,j);
		else Temp[i][j] = a(i,j);
		}
	return (Temp);
	}
Vector ebemul (const Vector &a, const Vector &b)
{
	short i;
	Vector Temp(a.nr,a.nc,'y');
	for(i = 0; i< a.nelem; i++){
		Temp.v[i] = a.v[i]*b.v[i];
		}
	return (Temp);
	}
/* ebemul with matrix row.  The arguments are a Matrix, the number of a row
	in the Matrix, and a Vector.  The return value is the column Vector 
	by element-by-element multiplication of the matrix row and the Vector.
	The returned vector has the same dimensions as the argument Vector.
	*/
Vector ebemul(const Matrix& a, short i, const Vector& b)
{
	short j;

	Vector Temp(b.nr,b.nc,'y');
	for(j = 0; j< b.nelem; j++){
		Temp.v[j] = a.m[i][j+a.fc]*b.v[j];
		}
	return (Temp);
	}

/* dot() -- dot take the dot product (or inner product) of any two vectors
	which have the same number of elements.  They can both be rows, or both
	columns, or one of each.  The value returned is a double.  It thus differs
	from the * operator between two vectors which (a) returns a Matrix and
	(b) requires that one vector be a row and the other a column.
	*/
double dot(const Vector& a, const Vector& b)
{
	short i;
	double sum;

	sum = 0;
	if(a.nelem != b.nelem){
		printf("Vectors of unequal length in dot.\n");
		return(sum);
		}
	for(i = 0;i < a.nelem;i++)
		sum += a.v[i]*b.v[i];
	return(sum);
	}

//////////////////////  THE MATRIX MEMBER FUNCTIONS /////////////////////////
Matrix::Matrix(short anr, short anc, char atemp, short afr, short afc)
{
	short i;

	which = vcount++;
	nr = anr;
	nc = anc;
	temp = atemp;
	fr = afr;
	fc = afc;
	lr = fr + nr - 1;
	lc = fc + nc - 1;
	if((m = new float* [nr]) == 0) goto gripe;
	m -= fr;
	for(i = fr; i <= lr; i++){
		if((m[i] = new float [nc]) == 0) goto gripe;
		m[i] -= fc;
		}
	return;
	gripe:
		cout << "Out of memory on array number " << which << ".\n";
		exit(1);
	}
Matrix::Matrix()
{
	which = vcount++;
	nr = 0;
	nc = 0;
	temp = 'n';
	fr = 0;
	fc = 0;
	lr = 0;
	lc = 0;
	m  = 0;
	return;
	}
Matrix::Matrix(Matrix& a)
{
	short i,j;
	which = vcount++;
	seq=-1;  // -1 indicates no position assigned.
	nr = a.nr;
	nc = a.nc;
	temp = a.temp;
	fr = a.fr;
	fc = a.fc;
	lr = a.lr;
	lc = a.lc;
	// See the note at this point in Vector::Vector(Vector& a), which
	// applies here also.
	if(a.temp == 'y'){
		m = a.m;
		a.m = 0;
		}
	else{
		m = 0;
		if((m = new float* [nr]) == 0) goto gripe;
		m -= fr;
		for(i = fr; i <= lr; i++){
			m[i] = 0;
			if((m[i] = new float [nc]) == 0) goto gripe;
			m[i] -= fc;
			}
		for(i = fr; i <= lr; i++){
			for(j = fc; j <= lc; j++)
				m[i][j] = a.m[i][j];
			}
		}
	return;
	gripe:
		cout << "Out of memory on array number " << which << ".\n";
		exit(1);
	}
Matrix::~Matrix()
{
	freeh();
	#ifdef DBG_DESTRUCT
	printf(" Calling destructor for Matrix.  temp = %c\r\n",
		temp);
	printf("    which = %d  seq = %d\r\n", which,seq);
	//if(name)
	//   printf(" name is %s\r\n", name);
	#endif
	#ifdef INCL_MATRIX
	if(DymeLoaded=='y')
		unload();  // turn off loaded flag in mats[] array.
	#endif
	}
 void Matrix::resize(int anr, int anc, int afr, int afc){
	int i;
	if(m!=0){
		printf("Cannot resize a matrix with content.\n");
		return;
		}
	nr = anr;
	nc = anc;
	fr = afr;
	fc = afc;
	lr = fr + nr - 1;
	lc = fc + nc - 1;
	if((m = new float* [nr]) == 0) goto gripe;
	m -= fr;
	for(i = fr; i <= lr; i++){
		if((m[i] = new float [nc]) == 0) goto gripe;
		m[i] -= fc;
		}
	return;
	gripe:
		cout << "Out of memory resizing array number " << which << ".\n";
		exit(1);
	}

/* claimh() is the opposite of freeh.  In conjunction with freeh, it allows
the user to grap heap memory for a matrix, use it, and then release it and
grab memory for another matrix. */

void Matrix::claimh()
{
	short i;

	if(m != 0) return;
	if((m = new float* [nr]) == 0) goto gripe;
	m -= fr;
	for(i = fr; i <= lr; i++){
		if((m[i] = new float [nc]) == 0) goto gripe;
		m[i] -= fc;
		}
	return;
	gripe:
		cout << "Out of memory on array number " << which << ".\n";
		exit(1);
	}
void Matrix::freeh()
{
	short i;

	if(m == 0) return;
	for(i = fr; i <= lr; i++){
		if(m[i]) {
			m[i] += fc;
			delete m[i];
			}
		}
	m += fr;
	delete m;
	m = 0;
	}

short Matrix::ReadA(char *filename)
{
	FILE *fp;
	short i,j,k;
	char s[241];

	if((fp = fopen(filename,"rt")) == 0){
		cerr << "Cannot open " << filename << ".\n";
		return(ERR);
		}
	fgets(s,240,fp);
	k = 0;
	for(i = fr; i <= lr; i++){
		for(j = fc; j <= lc; j++){
			if(getfloat(m[i][j],fp,s,k) == ERR)	break;
			}
		}
	fclose(fp);
	return(OK);
	}
void Matrix::Display(char *title,short width, short decimalPlaces)
{
	short i, j, nperline,line, linesPerRow=25;
	char fmt[20];

	if(strlen(title) > 0) printf("\n%s", title);
	line = 1;
	nperline = 71/(width+1);
	sprintf(fmt,"%s%d.%df", " %",width,decimalPlaces);
	for(i = fr; i <= lr; i++){
		for(j = fc; j <= lc; j++){	
			if((j-fc) % nperline == 0){
				if(j == fc) 
					printf("\n%3d",i);
				else {
					printf("\n   ");
					}
				printf(" %3d",j);
				line++;
				}
			printf(fmt,m[i][j]);
			}
		if(23 - line  < linesPerRow) {
			tap();
			line = 0;
			}
		}
	}
void Matrix::Display(FILE *fp,char *title,short width, short decimalPlaces)
{
	short i, j, nperline,line, linesPerRow=25;
	char fmt[20];

	if(strlen(title) > 0) fprintf(fp,"\n%s", title);
	line = 1;
	nperline = 71/(width+1);
	sprintf(fmt,"%s%d.%df", " %",width,decimalPlaces);
	for(i = fr; i <= lr; i++){
		for(j = fc; j <= lc; j++){
			if((j-fc) % nperline == 0){
				if(j == fc)
					fprintf(fp,"\n%3d",i);
				else {
					fprintf(fp,"\n   ");
					}
				fprintf(fp," %3d",j);
				line++;
				}
			fprintf(fp,fmt,m[i][j]);
			}
		if(23 - line  < linesPerRow) {
			//tap();
			line = 0;
			}
		}
	}
Matrix& Matrix::operator = (const Matrix& a)
{
	short i,j,nrmin,ncmin;
	nrmin = nr < a.nr ? nr : a.nr;
	ncmin = nc < a.nc ? nc : a.nc;

	if(nr != a.nr || nc != a.nc) {
//		cout << "Equating matrices of unequal size.\n";
		}
	for(i = 0; i < nrmin; i++){
		for(j = 0; j < ncmin; j++)
			m[fr+i][fc+j] = a.m[a.fr+i][a.fc+j];
		}
	a.freet();
	return(*this);
	}
/* This probably needs to be made a friend of Pmatrix, but I'm not
	sure yet how to declare it HERE.
	In Pmatrix:
	friend Matrix& Matrix::operator = (const Pmatrix& a);
*/
Matrix& Matrix::operator = (const Pmatrix& a) {
	short i,j,jcol;
	// Matrix must be smaller than or equal to Pmatrix to do assignment.
	// Then only copy those rows or columns that exist in Matrix.
	if(nr > a.nr || nc > a.nc) {
		cout << "Matrix must be smaller than or same size as Pmatrix (=).\n";
		return (*this);
		}
	// Zero out the Matrix:
	for(i=fr;i<=lr;i++)
		for(j=fc;j<=lc;j++)
			m[i][j]=0.0;
	// Walk through the Pmatrix by row, as usual.
	for(i=fr;i<=lr;i++)
		for(j=0;j<a.rnc[i];j++) {
			jcol=a.row[i][j];
			if(jcol>nc)
				continue;
			m[i][jcol]=a.p[i][j];
			}
	return(*this);
}
Matrix Matrix::operator ~ () //Transposition
{
	short i,j;

	Matrix Temp(nc,nr,'y',fc,fr);
	for(i = fr; i <= lr; i++){
		for(j = fc; j <= lc; j++)
			Temp.m[j][i] = m[i][j];
		}
	return(Temp);
	}		
float * Matrix::operator [](short i)
{
	if(m==0){
		cerr << "Error: Reference to a deleted Matrix.\n";
		exit(1);
		}

	if(i < fr || i > lr ){
		cerr << "illegal Matrix row index: " << i << "." << "\n";
		cerr << "returning first row. \n";
		return m[fr];
		}
	return(m[i]);
	}
Matrix Matrix::operator ! () // Inversion
{
	if(temp == 'n'){
		Matrix Temp(*this);
		Temp.temp = 'y';
		Temp.invert();
		return(Temp);
		}
	else{ // If this Matrix is temporary, turn it into its inverse.
		invert();
		return(*this);
		}
	}
// Turn a matrix into its inverse. The value returned is the determinant.  
double Matrix::invert(short startrow, short endrow)
{
	double pivot,determinant;
	short i, j, k;

	if(startrow == 0) startrow = fr;
	if(endrow   == 0) endrow   = lr;
	determinant = 1.;
	for(i = startrow; i <= endrow; i++){
		if((pivot = m[i][i])== 0.){
			printf("Zero diagonal; Matrix probably singular. Returning partly inverted Matrix.\n");
			return(determinant);
			}
		determinant *= pivot;
		m[i][i] = 1.;
		for (j = fc; j <= lc; j++)
			m[i][j] /= pivot;
		for (k = fr; k <= lr; k++){
			if(k == i) continue;
			pivot = m[k][i];
			m[k][i] = 0.;
			for(j = fc; j <= lc; j++)
				m[k][j] -= pivot*m[i][j];
			}
		}
	return(determinant);
	}
///////////////FRIENDS OF MATRIX AND VECTOR  ////////////////////
/*  M << b stores the vector b into the first column or row
	 of the Matrix M.  It seems impossible to use = for this
	 operation because the compiler insists that "operator ="
	 must be member, not merely a friend of the class. Thus it
	 is impossible to get at the protected elements of two different
	 classes in an "operator =" function.  Hence the use of <<.
	 */
void operator << (Matrix& a, const Vector& b)
{
	short i, nrmin, ncmin;
	nrmin = min(a.nr,b.nr);
	ncmin = min(a.nc,b.nc);
	if(a.nr != b.nr || a.nc != b.nc)
		cout << "<< applied to arrays of unequal size.\n";
	if(b.nc == 1){  //The vector is a column
		for(i=0;i<nrmin;i++)
			a.m[a.fr+i][a.fc] = b.v[i];
		}
	else{
		for(i= 0;i<ncmin;i++)
			a.m[a.fr][a.fc+i] = b.v[i];
		}
	b.freet();
	}

Matrix operator + (const Matrix &a, const Matrix &b)
{
	short i,j,fr,lr,fc,lc;
	if(b.fr != a.fr || b.lr != a.lr){
		cout << "Matrix dimensions do not match in + operator.\n";
		cout << "adding overlapping areas into a Matrix with dimensions of the left one.\n";
		}
	fr = max(a.fr,b.fr);
	lr = min(a.lr,b.lr);
	fc = max(a.fc,b.fc);
	lc = min(a.lc,b.lc);
	
	Matrix Temp(a.nr,a.nc,'y');
	for(i = fr; i <= lr; i++){
		for(j = fc; j <= lc; j++)
			Temp.m[i][j] = a.m[i][j] + b.m[i][j];
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Matrix operator - (const Matrix &a, const Matrix &b)
{
	short i,j,fr,lr,fc,lc;
	if(b.fr != a.fr || b.lr != a.lr){
		cout << "Matrix dimensions do not match in + operator.\n";
		cout << "adding overlapping areas into a Matrix with dimensions of the left one.\n";
		}
	fr = max(a.fr,b.fr);
	lr = min(a.lr,b.lr);
	fc = max(a.fc,b.fc);
	lc = min(a.lc,b.lc);

	Matrix Temp(a.nr,a.nc,'y');
	for(i = fr; i <= lr; i++){
		for(j = fc; j <= lc; j++)
			Temp.m[i][j] = a.m[i][j] - b.m[i][j];
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Matrix operator * (const float a, const Matrix& b)
{
	short i,j;
	Matrix Temp(b.nr,b.nc,'y');
	for(i = b.fr; i <= b.lr; i++){
		for(j = b.fc; j <= b.lc; j++) {
			Temp.m[i][j] = a*b.m[i][j];
			//x = Temp.m[i][j];
			//y = b.m[i][j]; // only for debugging.
			}
		}
	b.freet();
	return(Temp);
	}
Matrix operator / (const Matrix& a, const float b)
{
	short i,j;
	float recip;

	recip = 0;
	if(b != 0) recip = 1./b;
	else {
		printf("Dividing a Matrix by 0. Result is 0.\n");
		}
	Matrix Temp(a.nr,a.nc,'y'); 
	for(i = a.fr; i <= a.lr; i++){
		for(j = a.fc; j <= a.lc; j++)
			Temp.m[i][j] = recip*a.m[i][j];
		}
	a.freet();
	return(Temp);
	}
Matrix operator * (const Matrix &a, const Matrix &b)
{
	short i,j,k;
	double sum;

	Matrix Temp(a.nr,b.nc,'y',a.fr,b.fc); 
	for(i = a.fr; i <= a.lr; i++){
		for(j = b.fc; j <= b.lc; j++)
			Temp.m[i][j] = 0.;
		}
	if(a.nc != b.nr){
		cout << "Matrix dimensions do not match in * operator.\n";
		cout << "returning a zero Matrix.\n";
		}
	else {
		for(i = a.fr; i <= a.lr; i++){
			for(j = b.fc; j <= b.lc; j++){
				sum = 0;
				for(k = 0; k < a.nc; k++)
					sum += a.m[i][a.fc+k]*b.m[b.fr+k][j];
				Temp.m[i][j] = sum;
				}
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Vector operator * (const Vector& a, const Matrix& b)
{
	short i,j;
	double sum;

	Vector Temp(a.nr,b.nc,'y',a.fr,b.fc);
	for(i = 0; i < Temp.nelem; i++){
		Temp.v[i] = 0.;
		}
	if(a.nc != b.nr){
		cout << "Vector*Matrix dimensions do not match.\n";
		cout << "returning a zero Vector.\n";
		}
	else {
		for(i = 0; i < Temp.nelem; i++){
			sum = 0;
			for(j = 0; j < b.nr ; j++)
				sum += a.v[j]*b.m[b.fr+j][b.fc+i];
			Temp.v[i] = sum;
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Vector operator * (const Matrix& a, const Vector& b)
{
	short i,j;
	double sum;

	Vector Temp(a.nr,b.nc,'y',a.fr,b.fc); 
	for(i = 0; i < Temp.nelem; i++){
		Temp.v[i] = 0.;
		}
	if(a.nc != b.nr){
		cout << "Matrix*Vector dimensions do not match.\n";
		cout << "returning a zero Vector.\n";
		}
	else {
		for(i = 0; i < Temp.nelem; i++){
			sum = 0;
			for(j = 0; j < a.nc; j++)
				sum += a.m[a.fr+i][a.fc+j]*b.v[j];
			Temp.v[i] = sum;
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Matrix operator * (const Vector& a, const Vector& b)
{
	short i,j,k;
	double sum;

	Matrix Temp(a.nr,b.nc,'y',a.fr,b.fc); 
	for(i = a.fr; i <= a.lr; i++){
		for(j = b.fc; j <= b.lc; j++)
			Temp.m[i][j] = 0.;
		}
	if(a.nc != b.nr){
		cout << "Vector*Vector dimensions do not match.\n";
		cout << "returning a zero Matrix.\n";
		}
	else {
		for(i = a.fr; i <= a.lr; i++){
			for(j = b.fc; j <= b.lc; j++){
				sum = 0;
				for(k = 0; k < a.nc; k++)
					sum += a.v[k]*b.v[k];
				Temp.m[i][j] = sum;
				}
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}
/* ==================================================================== */
// Matrix % operator is diagonalized postmultiply.  If the first Matrix
//   	is m X n, the Vector b must be of length n, so that the 
//   	implicit diagonalized Matrix is n X n.  The result is an
//    m X n matrix which is the product of the original Matrix
//   	and the diagonalized Vector.

Matrix operator % (const Matrix& a, const Vector& b)
{
	short i,j;
	double sum;

	Matrix Temp(a.nr,a.nc,'y',a.fr,a.fc); // same dim as matrix
	if(a.nc != b.nelem){
		cout << "Vector*matrix dimensions do not match.\n";
		cout << "returning a zero Vector.\n";
		}
	else {
		for(i = a.fr; i <= a.lr; i++){
			for(j = 0; j < b.nelem; j++){
				sum = a.m[i][j+a.fc] * b.v[j];
				Temp.m[i][j+a.fc] = sum;
				}
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}

//======================================================================
// Diagonalized premultiply.
Matrix operator % (const Vector& b, const Matrix& a)
{
	short i,j;
	double sum;

	Matrix Temp(a.nr,a.nc,'y',a.fr,a.fc); // same dim as matrix
	if(a.nr != b.nelem){
		cout << "Vector*Matrix dimensions do not match.\n";
		cout << "returning a zero Vector.\n";
		}
	else {
		for(i = 0; i < b.nelem; i++){
			for(j = a.fc; j <= a.lc; j++){
				sum = a.m[i+a.fr][j] * b.v[i];
				Temp.m[i+a.fr][j] = sum;
				}
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}

// A/B gives what is usually written as A'B, but without creating A'.
Matrix operator / (const Matrix& a, const Matrix& b)
{
	short i,j,k,n;
	double sum;

	Matrix Temp(a.nc,b.nc,'y',a.fc,b.fc);

	if(a.nr != b.nr){
		cerr << "Matrices do not have same number of rows in / operator.\n";
		cerr <<  "Using the smaller number.\n";
		}
	n = min(a.nr,b.nr);
	for (i = a.fc; i <= a.lc; i++){
		for(j = b.fc; j <= b.lc; j++){
			sum = 0;
			for(k = 0; k < n; k++)
				sum += a.m[a.fr+k][i]*b.m[b.fr+k][j];
			Temp.m[i][j] = sum;
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Vector operator / (const Matrix& a, const Vector& b)
{
	short i,k,n;
	double sum;

	Vector Temp(a.nc,b.nc,'y',a.fc,b.fc);

	if(a.nr != b.nr){
		cerr << "Matrices do not have same number of rows in / operator.\n";
		cerr <<  "Using the smaller number.\n";
		}
	n = min(a.nr,b.nr);
	for (i = a.fc; i <= a.lc; i++){
		sum = 0;
		for(k = 0; k < n; k++)
			sum += a.m[a.fr+k][i]*b.v[k];
		Temp.v[i-a.fc] = sum;
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Vector operator / (const Vector& a, const Matrix& b)
{
	short j,k,n;
	double sum;

	Vector Temp(a.nc,b.nc,'y',a.fc,b.fc);

	if(a.nr != b.nr){
		cerr << "Vector and Matrix do not have same number of rows in / operator.\n";
		cerr <<  "Using the smaller number.\n";
		}
	n = min(a.nr,b.nr);
	for(j = b.fc; j <= b.lc; j++){
		sum = 0;
		for(k = 0; k < n; k++)
			sum += a.v[k]*b.m[b.fr+k][j];
		Temp.v[j-b.fc] = sum;
		}
	a.freet();
	b.freet();
	return(Temp);
	}
Matrix operator / (const Vector& a, const Vector& b)
{
	short i,j,k,n;
	double sum;

	Matrix Temp(a.nc,b.nc,'y',a.fc,b.fc);

	if(a.nr != b.nr){
		cerr << "Vectors do not have same number of rows in / operator.\n";
		cerr <<  "Using the smaller number.\n";
		}
	n = min(a.nr,b.nr);
	for (i = a.fc; i <= a.lc; i++){
		for(j = b.fc; j <= b.lc; j++){
			sum = 0;
			for(k = 0; k < n; k++)
				sum += a.v[i-a.fc+k]*b.v[j-b.fc+k];
			Temp.m[i][j] = sum;
			}
		}
	a.freet();
	b.freet();
	return(Temp);
	}
short pulloutcol(Vector& V, Matrix& A, short k){
	short i,fr,lr,fc,lc;

	fr = A.firstrow();
	lr = A.lastrow();
	fc = A.firstcolumn();
	lc = A.lastcolumn();

	if(k < fc || k > lc){
		printf("Column to be extracted, %d, is out of range.\n",k);
		tap();
		return(ERR);
		}

	for(i = fr; i <= lr; i++)
		V[i] = A[i][k];
	return(OK);
	}
short pulloutrow(Vector& V, Matrix& A, short k){
	short i,fr,lr,fc,lc;

	fr = A.firstrow();
	lr = A.lastrow();
	fc = A.firstcolumn();
	lc = A.lastcolumn();

	if(k < fr || k > lr){
		printf("Row to be extracted, %d, is out of range.\n",k);
		tap();
		return(ERR);
		}

	for(i = fc; i <= lc; i++)
		V[i] = A[k][i];
	return(OK);
	}
short putincol(Vector& V, Matrix& A, short k){
	short i,fr,lr,fc,lc;

	fr = A.firstrow();
	lr = A.lastrow();
	fc = A.firstcolumn();
	lc = A.lastcolumn();

	if(k < fc || k > lc){
		printf("Column to be inserted, %d, is out of range.\n",k);
		tap();
		return(ERR);
		}
	for(i = fr; i <= lr; i++)
		A[i][k] = V[i];
	return(OK);
	}
short putinrow(Vector& V, Matrix& A, short k){
	short i,fr,lr,fc,lc;

	fr = A.firstrow();
	lr = A.lastrow();
	fc = A.firstcolumn();
	lc = A.lastcolumn();

	if(k < fr || k > lr){
		printf("Row to be inserted, %d, is out of range.\n",k);
		tap();
		return(ERR);
		}
	for(i = fc; i <= lc; i++)
		A[k][i] = V[i];
	return(OK);
	}
Vector colsum(const Matrix& A){
	short i,j, fr,lr,fc,lc,nc;
	double sum;

	fr = A.firstrow();
	lr = A.lastrow();
	fc = A.firstcolumn();
	lc = A.lastcolumn();
	nc  = A.columns();
	Vector Temp(nc,1,'y',fc,1);
	for(i = fc; i < lc; i++)
		Temp[i] = 0.;
	for(j = fc; j <= lc; j++){
		sum = 0.;
		for(i = fr; i <= lr; i++)
			sum += A(i,j);
		Temp[j] = sum;
		}
	
	return(Temp);
	}
Vector rowsum(const Matrix& A){
	short i,j, fr,lr,fc,lc,nr;
	double sum;

	fr = A.firstrow();
	lr = A.lastrow();
	fc = A.firstcolumn();
	lc = A.lastcolumn();
	nr = A.rows();

	Vector Temp(nr,1,'y',fr,1);
	for(j = fr; j < lr; j++)
		Temp[j] = 0.;
	for(i = fr; i <= lr; i++){
		sum = 0.;
		for(j = fc; j <= lc; j++)
			sum += A(i,j);
		Temp[i] = sum;
		}
	
	return(Temp);
	}
short readmat(Matrix& A, char *filename){
	char card[2000];
	short i,j,k,year;
	short rowa,rowz,cola,colz,skip;
	float cell;
	FILE *fp;

	if((fp =fopen(filename,"rt")) == 0){
		printf("Cannot open %s\n",filename);
		exit(1);
		}
	// read start row, stop row, start col, stop col, skip
	fgets(card,2000,fp);
	j = 0;
	getint(year,fp, card, j);
	getint(rowa, fp, card, j);
	getint(rowz, fp, card, j);
	getint(cola, fp, card, j);
	getint(colz, fp, card, j);
	getint(skip, fp, card, j);

	for(i= rowa; i <= rowz; i++){
		again: fgets(card,2000,fp);
		if(card[0] == '#') goto again;
		j = skip;
		for(k = cola; k <= colz; k++){
			if(getfloat(cell,fp,card,j) != OK){
				printf("Out of data for row %d in %s.\n", i,filename);
				tap();
				}
			A[i][k] = cell;
			}
		}
	fclose(fp);
	return(OK);
	}
short writemat(Matrix& A, char *filename,short width,short decimalPlaces){
	char fmt[20];
	short i,j, fr,fc,lr,lc;
	FILE *fp;

	fr = A.firstrow();
	fc = A.firstcolumn();
	lr = A.lastrow();
	lc = A.lastcolumn();

	fp = fopen(filename,"wt");
	// Write the column numbers across the top.
	sprintf(fmt," %s%dd", "%",width);
	fprintf(fp,"#  ");
	for(i = fc; i <= lc; i++){
		fprintf(fp,fmt,i);
		}
	// Write the body of the matrix. 
	sprintf(fmt," %s%d.%df", "%",width,decimalPlaces);
	for(i = fr; i <= lr; i++){
		fprintf(fp,"\n%3d",i);
		for(j = fc; j <= lc; j++)
			fprintf(fp,fmt, A[i][j]);
		}
	fclose(fp);
	return(OK);
	}
/* ras() balances the Matrix A to have the vector "row" as row controls
and the vector "col" as columns controls.	*/
short ras(Matrix& A, Vector& row, Vector& col)
{
	char c;
	short i, j, iter,ncols, nrows, imax,jmax;
	float rsum,csum,dis,dismax,rdismax,cdismax,cdis,rdis;
	nrows = A.rows();
	ncols = A.columns();

	// Ensure that the sum of the controls are the same
	rsum = 0.; csum = 0.;
	for(i= 1; i <= nrows; i++)
		rsum += row[i];
	for(j = 1; j <= ncols; j++)
		csum += col[j];

	printf("\r\nSum of row controls %8.2f",rsum);
	printf("\r\nSum of col controls %8.2f",csum);
	if(fabs(csum - rsum) > 0.){
		query: printf("\r\nWhich governs, r or c? (Esc to exit)");
		c = getch();
		printf("\r\n");
		if(c == 'r'){
			rsum = rsum/csum;
			for(j = 1; j <= ncols; j++)
				col[j] *= rsum;
			}
		else if(c == 'c'){
			csum = csum/rsum;
			for(i = 1; i <= nrows; i++)
				row[i] *=csum;
			}
		else if(c == ESC){
			return(ERR);
			}
		else goto query;
		}
	printf("Iter row discrep col discrep\r\n");
	iter = 0;
	top:
	iter++;
	rdismax = 0.;
	cdismax = 0.;
		// scale columns
	for(j= 1; j <= ncols; j++){
		if(col[j] == 0) continue;
		csum = 0.;
		for(i = 1; i <= nrows; i++)
			csum += A[i][j];
		if(fabs(csum) > 0) csum = col[j]/csum;
		else csum = 0.;
		for(i = 1; i <= nrows; i++)
			A[i][j] *= csum;
		dis = fabs(csum -1.);
		if(dis > cdismax) {
			cdismax = dis;
			cdis = csum -1.;
			jmax = j;
			}
		}
	// scale rows
	for(i= 1; i <= nrows; i++){
		if(row[i] == 0) continue;
		rsum = 0;
		for(j = 1; j <= ncols; j++)
			rsum += A[i][j];
		if(fabs(rsum) > 0) rsum = row[i]/rsum;
		else rsum = 0.;
		for(j = 1; j <= ncols; j++)
			A[i][j] *= rsum;
		dis = fabs(rsum -1.);
		if(dis > rdismax) {
			rdismax = dis;
			rdis = rsum -1.;
			imax = i;
			}
		}
	// convergence check
	if(iter % 5 == 0)
		printf("%3d %3d %7.5f %3d %7.5f\r\n",iter,imax,rdis,jmax,cdis);
	dismax = cdismax > rdismax ? cdismax : rdismax;
	if(iter % 30 != 0 && dismax > .0002) goto top;
	if(dismax > .0002){
		printf("\r\nDid not converge. Max discrep = %8.5f.",dismax);
		printf("\r\nShall I a)bandon? c)ontinue trying? or u)se result?");
		c = getch();
		printf("\r\n");
		if(c == 'c') goto top;
		if(c == 'a') {
			return(ERR);
			}
		}
	return(OK);
	}
///////////////// The IVector member functions  /////////////////////////

IVector::IVector(short anr, short anc, char atemp, short afr, short afc)
{
	if(anr != 1 && anc != 1){
		cout << "Either the number of rows or the number of columns must be 1.\n";
		return;
		}
	which = vcount++;
	seq=-1;  // -1 indicates no position assigned.
	nr = anr;
	nc = anc;
	temp = atemp;
	fr = afr;
	fc = afc;
	lr = fr + nr - 1;
	lc = fc + nc - 1;
	nelem = nr + nc - 1;
	if(nc == 1) first = fr;
	else first = fc;
	if(nelem < 0 || nelem > 16000){
		cout << nelem << "is an illegal number of elements for a Vector.\n";
		return;
		}
	if(nelem == 0)
		v = 0;
	else if((v = new short[nelem]) == 0)
		cout << "Out of memory.\n";
	}
//=======================================================================
IVector::IVector(IVector& a)
{
	short i;

	which = vcount++;
	seq=-1;  // -1 indicates no position assigned.
	nr = a.nr;
	nc = a.nc;
	temp = a.temp;
	fr = a.fr;
	fc = a.fc;
	lr = a.lr;
	lc = a.lc;
	first = a.first;
	nelem = a.nelem;

	if(a.temp == 'y'){
		v = a.v;
		a.v = 0;
		}
	else{
		if((v = new short[nelem]) == 0){
			cout << "Out of memory trying to create IVector" << which <<".\n";
			exit(1);
			}
		for(i = 0; i < nelem; i++)
			v[i] = a.v[i];
		}
	}
IVector::IVector()
{
	which = vcount++;
	seq=-1;  // -1 indicates no position assigned.
	nr = 0;
	nc = 0;
	temp = 'n';
	fr = 0;
	fc = 0;
	lr = 0;
	lc = 0;
	first = 0;
	nelem = 0;
	v = 0;
	}
IVector::~IVector()
{
	#ifdef DBG_DESTRUCT
	printf(" Calling destructor for IVector.  temp = %c\r\n",
		temp);
	printf("    which = %d  seq = %d\r\n", which,seq);
	//if(name)
	//   printf(" name is %s\r\n", name);
	#endif
	if(v != 0)
		delete v;
	v = 0;
	}
// Free heap memory
void IVector::freeh()
{
	if(v != 0) delete v;
	v = 0;
	}
short IVector::ReadA(char *filename)
{
	FILE *fp;
	short i,j,k;
	char s[241],field[30];

	if((fp = fopen(filename,"rt")) == 0){
		cerr << "Cannot open " << filename << ".\n";
		return(ERR);
		}
	fgets(s,240,fp);
	j = 0;
	for(i = 0; i < nelem; i++){
		if(getint(v[i],fp,s,j) == ERR){
			cerr << "Out of data in " << filename << ".\n";
			break;
			}
		}
	fclose(fp);
	return(OK);
	}
void IVector::Display(char *title,short width)
{
	short i, nperline;
	char fmt[20];

	if(strlen(title) > 0) printf("\n%s", title);

	nperline = 76/(width +1);
	sprintf(fmt," %%dd", "%",width);

	for(i = 0;i<nelem;i++){
		if(i % nperline == 0) printf("\n%3d",i+fr+fc-1);
		printf(fmt,v[i]);
		}
	}
void IVector::set(short value){
	short i;
	for(i = 0; i < nelem; i++)
		v[i] = value;
	}

void IVector::resize(int nra, int nca, int fra, int fca)
{
	int i;
	if(v != 0){printf("Cannot resize an IVector with content.\n"); return;}
	nr = nra;
	nc = nca;
	fr = fra;
	fc = fca;
	lr = fr+nr-1;
	lc = fc+nc-1;
	if(nca == 1) first = fra;
    else first = fca;
	nelem = max(nr,nc);
	if((v = new short[nelem]) == 0){
		cout << "Out of memory trying to resize IVector" << which <<".\n";
		exit(1);
		}
	for(i = 0; i < nelem; i++)
		v[i] = 0.;
	}

IVector& IVector::operator = (const IVector& a)
{
	short i;
	short s = (nelem < a.nelem) ? nelem : a.nelem;

	for(i = 0; i < s; i++){
		v[i] = a.v[i];
		}
	a.freet();
	return(*this);
	}
short& IVector::operator [](short i)
{
	if(v==0){
		cerr << "Error: Reference to a deleted IVector.\n";
		exit(1);
		}
	if(nc == 1){
		if (fr > i || lr < i){
			printf("Illegal IVector index: %d . Returned first element.\n",i);
			return(v[fr-fr]); // was exit(1); changed to allow tracing back in debuger.
			}
		return(v[i - fr]);
		}
	else{
		if (fc > i || lc < i){
			cerr << "illegal IVector index: " << i << "\n";
			exit(1);
			}
		return(v[i - fc]);
		}
	}
