#include "dymesys.h"
#
float funk(float *x);
void amoeba(float **p, float y[], int ndim, float ftol, float (*funk)(float []));
int memload();
short nparam; // Number of parameters involved in maximizing
char   static1, *stochastic_indicator, *MaxFile;
short *eqnum,*coefnum, ns_model,span,period,first;
float *stepsize, date1;
extern void spin();
FILE *fpConvCheck;

#include "databank.h"
//FILE *fpdat;
/*******************************************************************/
/*
    this function reads heart.dim and gets the number of coeff's in
    each equation, and returns the number of equations.
*/
int  coefdim(void)
{
    char card[20];
    FILE  *fpdim;
    int i, j;

    if ((fpdim = fopen("heart.dim", "rt")) == NULL) {
        fprintf(stderr, "Cannot open heart.dim\n");
        exit(3);
        }

    fgets(card,20,fpdim);
    EquationCount = atoi(card);
    stochastic_indicator = (char *)malloc(EquationCount);
    ncoef = (short *)malloc(EquationCount*sizeof(short));

    i = 0;
    while(fgets(card,20,fpdim) != NULL){
        stochastic_indicator[i] = card[0];
        ncoef[i] = atoi(&card[1]);
        i++;
        }

//Get space for the coef's.  coef was declared in dyme.h

    coef = new float* [EquationCount];
    for(i = 0; i < EquationCount; i++)
        coef[i] = new float [ncoef[i]];

/* Does not work
    while (fscanf(fpdim, "%s %d", &stochastic_indicator[i], &ncoef[i]) != EOF)
        i++;
*/
/*
    This block prints parameters for checking

    printf("nequ = %d\n", i);
    for (j = 0; j < i; j++)
        printf("ncoef[%d] = %d\n", j, ncoef[j]);
*/
    fclose(fpdim);
    return i;
} // end coefdim

/*******************************************************************/
/*
    this function reads coefficients, rho, see, and principal
    component matrix of vc matrix from heart.dat;
    and fills global variables coef, rho1 and see1
    if stochastic indicator = d or  rndcoef = NO, coef are deterministic
                              s and           YES,          random
*/
void coefgen(void){
    char    vname[20], temp[20];
    int  i, j, ii, jj, k;
    float  **a, *u;
    static char coefgen_first_pass = 1;
    //static struct {char first_pass: 1;} flags = {1};

    if (coefgen_first_pass){
        coefgen_first_pass = 0;
        if ((fpdat = fopen("heart.dat", "rt")) == NULL) {
            fprintf(stderr, "Cannot open heart.dat\n");
            exit(3);
        }
    }

    /* rewind pointer in heart.dat */
    rewind(fpdat);

    i = 0;          /* coef[i][] */
    while (i < nequ)
    {
        /* dependent variable name */
        fscanf(fpdat, "%s", vname);
        while (fgetc(fpdat) != '\n' );

        /* coeff = */
        fscanf(fpdat, "%s", temp);
        if (strcmp(temp, "coeff") != 0) {
            fprintf(stderr,"\nFound %s when I was expecting  Coeff\n",temp);
            fprintf(stderr,"before equation %d for %s (?) in heart.dat\n",
                i+1, vname);
            exit(4);
        }
        while (fgetc(fpdat) != '\n' );

        /* coef[][j] */
        j = 0;      /* coef[][j] */
        while (j < ncoef[i])
            fscanf(fpdat, "%f", &coef[i][j++]);
        if (i < nequ-1)
            while (fgetc(fpdat) != '\n' );

        if (stochastic_indicator[i] == 's') {
            /* rho */
            while (fgetc(fpdat) != '=' );
            fscanf(fpdat, "%f", &rho1[i]);
            while (fgetc(fpdat) != '\n' );

            /* see */
            while (fgetc(fpdat) != '=' );
            fscanf(fpdat, "%f", &see1[i]);
            while (fgetc(fpdat) != '\n' );

            /* pc matrix */
            if ((a = matrix(0, ncoef[i]-1, 0, ncoef[i]-1)) == NULL)
                exit(4);
            while (fgetc(fpdat) != '\n' );    /* pass pc_matrix = */
            k = 0;
            while (k < ncoef[i]*ncoef[i]){
                fscanf(fpdat, "%f", &a[k/ncoef[i]][k%ncoef[i]]);
                k++;
                }

            /*
                has collected all parameters for one equ.  process it here.
            */

            /*
                Generate random coefficients as c + Au, where
                c is point estimate of coefficients
                A is Square root of variance-covariance matrix of c
                u is random, normal(0,1).
            */
            if (rndcoef == YES)
            {
                if ((u = vector(0, ncoef[i]-1)) == NULL)
                    exit(9);
                for (j = 0; j < ncoef[i]; j++)
                    u[j] = normal();
                for (k = 0; k < ncoef[i]; k++)
                    for (j = 0; j < ncoef[i]; j++)
                        coef[i][k] += a[k][j] * u[j];
                free_vector(u, 0);
            }

/*
            This block prints parameters for checking

            printf( "%s\n", vname);
            printf( "coeff = ");
            for(jj = 0; jj < ncoef[i]; jj++) {
                if (jj % 4 == 0)
                    printf("\n");
                printf("%12.6f  ", coef[i][jj]);
            }
            printf("\n");
            printf( "rho = %f\n", rho1[i]);
            printf( "see = %f\n", see1[i]);
            printf( "pc_matrix = ");
            for(ii = 0; ii < ncoef[i]; ii++) {
                for(jj = 0; jj < ncoef[i]; jj++) {
                    if (jj % 4 == 0)
                        printf("\n");
                    printf("%12.6f  ", a[ii][jj]);
                    }
                }
            printf("\n");
*/

            /* make ready for next equation */
            free_matrix(a, 0, ncoef[i]-1, 0);
            /* move stream to next equation */
            if (i < nequ-1)
                while (fgetc(fpdat) != '\n' );

            } /* end of stochastic_indicator == s */
        i++;
        }  /* end while */
    }// end coefgen

/*******************************************************************/
/* Gaussian deviates - from Numerical Methods in C where it is called gasdev. */
float normal(){
    static int iset=0;
    static float gset;
    float fac,r,v1,v2;

    if(iset == 0) {
        do {
            v1=2.0*ran0()-1.0;
            v2=2.0*ran0()-1.0;
            r=v1*v1+v2*v2;
            } while (r >= 1.0);
        fac=sqrt(-2.0*safelog(r)/r);
        gset=v1*fac;
        iset=1;
        return v2*fac;
        }
    else {
        iset=0;
        return gset;
        }
    }  // end normal

/* Random number generator shuffler from Numerical Methods in C */

float ran0(){
    static float y,maxran,v[98];
    float dum;
    static int iff=0;
    short j;
    unsigned short i,k;

    if (ranseed < 0 || iff == 0) {
        iff=1;
        i=2;
        do {
            k=i;
            i<<=1;
            } while (i);
        maxran=k;
        srand(ranseed);
        ranseed=1;
        for (j=1;j<=97;j++) dum=rand();
        v[0] = dum;
        for (j=1;j<=97;j++) v[j]=rand();
        y=rand();
        }
    j=1 + 97.0*y/maxran;
    if (j > 97 || j < 1) printf("RAN0: This cannot happen.");
    y=v[j];
    v[j]=rand();
    return y/maxran;
    }  // end ran0
/**********************************************************************
Here start the maximization routines.
***********************************************************************/
int maxsolve(){
#define MaxRunLength 200
    char c;
    int  i,j,runs;
    float sum, ftol, **points,*values,*params,ss[MaxRunLength+1],*oldparams,*oldpoints;
    float val;

    runs = 1;
    // ftol is the convergence criterion in amoeba.  It is the difference between
    // the value of the objective function at the best and worst points
    // as a fraction of their sum.
    ftol = 0.001;
    /* load the initial data   -- this is done in the Initialize function in idlopt*/
    //printf("\n\nLoading time series data.\n");
    //if (memload() == ERR) exit(2);
    //printf("Time series data loaded. Load coefficients.\n");
    // an "ER:" marks the comments of Ernesto Reuben
/* Removed by CA until I understand the function of this code
    // ER:   Make a copy of the original values of vp to later copy for each approximation
   for(i = 0; i < ns_model; i++)
        for ( t = 0; t <= span; t++)
            mvp[i][t] = vp[i][t];
*/
#if defined(MACRO_INCL)
    if((iobjective = gb.findname(objective)) < 0){
        printf("This model does not have a variable named %s,\n",objective);
        printf("the name you gave in the OptSpec file as the variable to be optimized.\n");
        return NO;
        }
#endif
    points = matrix(1,nparam+1,1,nparam);
    oldpoints = vector(1,nparam);    // ER: stores the results of the first maximization
    values = vector(1,nparam+1);
    oldparams = vector(1,nparam);    // ER: added oldparams to compare results
    params = vector(1,nparam);

    fpConvCheck= fopen("Amoeba.chk","wt");

    /* set increment in date */
    increment = 1.;
    if (npy == 4) increment = .1;
    if (npy == 12) increment = .001;

    // ER: Loop that runs until no further improvement is possible.
    while(1){
    //Fill in the matrix of starting parameter points of the simplex.
    //If we are optimizing nparam parameters, we need nparam+1 points.
    //They start all the same, and then we add its stepsize to one dimension of each point.
        for(i = 1; i <= nparam+1; i++){ // ER: added 1 to nparam so that the last row is not zeros
            for(j = 1; j <= nparam; j++){
                if (runs == 1)
                    points[i][j] = coef[eqnum[j-1]][coefnum[j-1]];
                else
                    // ER: if it is not the first maximization use the new
                 // coefficients as the starting point of the new simplex
                    points[i][j] = points[1][j];
                }
            }
        for(i = 1; i <= nparam+1; i++){ // ER: go to nparam+1 so that the last point is also modified
            if(i>1) points[i][i-1] += stepsize[i-2]; // ER: since stepsize starts at zero changed stepsize[i-1] to stepsize[i-2]
            for(j = 1; j <= nparam; j++)
                params[j] = points[i][j];
            values[i] = funk(params);
            if(i > 1){
                if(values[i] > values[1]){// Did the variation in the point give a better value to the objective function?
                    // If not, try moving in the opposite direction
                    val = values[i];
                    points[i][i-1] -= 2.*stepsize[i-2];
                    params[i-1] = points[i][i-1];
                    values[i] = funk(params);
                    if(val < values[i]){ // if that made matters worse, go back to a movement of 10% of the step size in the other direction
                        points[i][i-1] += 1.1*stepsize[i-2];
                        params[i-1] = points[i][i-1];
                        values[i] = funk(params);
                        }
                    else if (values[1] < values[i]){ // Movement in the negative direction was better than in the positive,
                        points[i][i-1] += .9*stepsize[i-2]; // but still hurt, so take only 1/10 of a step.
                        params[i-1] = points[i][i-1];
                        values[i] = funk(params);
                        }
                    }
                }
            }
        if(runs >1){
            val = values[1];
            for(j = 2; j <= nparam+1; j++){
                if(values[j] < val) val = values[j];
                }
            if( values[1] <= val*1.01) break; // stop iterations
            printf("Simplex Optimum was %12.6f; Probing found %12.6f.\n",values[1],val);
            }


        else{
        // ER: if there is no change in the objective function no maximization will occur.
        sum = 0.0;
        for(i = 2; i <= nparam+1; i++)
            sum += fabs(values[i] - values[i-1]);
        if (sum < ftol){
            printf("There was no significant change in the objective function.\n");
            printf("Revise the step size and/or the objective function.\n");
            return NO;
            }
        }

        if (runs == 1)
            for(j = 1; j <= nparam; j++)
                oldparams[j] = params[j];   // ER: Save params for comparison

        //  Go maximize

        amoeba(points,values,nparam, ftol, funk);


        for(i = 1; i <= nparam; i++)
            oldpoints[i] = points[1][i];
        runs++;
        }


    // Here when optimum has been found
    // ER: Printing initial and new params.
    FILE *fpChange;
    fpChange = fopen("Changes.chg","wt");
    printf("\nResulting coeficients after maximization (%d runs).\n", runs+1);
    printf("Variable\tOld:\t\t\tNew:\n");
    fprintf(fpChange,"\nResulting coeficients after maximization (%d runs).\n", runs+1);
    fprintf(fpChange,"Variable\tOld:\t\t\tNew:\n");
    for(j = 1; j <= nparam; j++){
        printf("%s\t\t%8.4f\t\t%8.4f\n",eqname[j-1],oldparams[j],points[1][j]);
        fprintf(fpChange,"%s\t\t%8.4f\t\t%8.4f\n",eqname[j-1],oldparams[j],points[1][j]);
        }
    printf("\nThis information is in the file Changes.chg.\n");
    fclose(fpChange);
    fclose(fpConvCheck);


    // ER: Update coef and copy original values into vp to run the model with new coefficients
    for(t = 0; t < nparam;t++){
        i = eqnum[t];
        j = coefnum[t];
        coef[i][j] = points[1][t+1];
        }

    /* Removed until CA understands the purpose
    for(i = 0; i < ns_model; i++)
        for ( t = 0; t <= span; t++)
                vp[i][t] = mvp[i][t];
    */

    // ER: save results
    if (coefwrite() == NO) return NO;

    printf("\nPress any key to run the model with the new coefficients.\n");
    getch();
    free_matrix(points,1,nparam+1,1);
    free_vector(oldpoints,1);
    free_vector(values,1);
    free_vector(oldparams,1);
    free_vector(params,1);
    return YES;
    }  // end maxsolve
/*****************************************************
funk calculates the value of the objective function
given the vector of parameters, x.
*****************************************************/
int MaxIter = 40; // dummy, replace later
float ObjectiveValue;
float funk(float *x){
    int i,j, ii, count;
    short c,iter_count, ObjPeriod;
    float datenow;

    // Store the parameters into the correct cells of coeff
   for(ii = 0; ii < nparam; ii++){
        i = eqnum[ii];
        j = coefnum[ii];
        coef[i][j] = x[ii+1];      // ER: Changed to [ii+1] since params[] started at 1 so x[] should start at 1 too.
        }
   // Do one spin through the Intedyme model
    spin();
   // ER: Copy original values into vp to run the approximation
    /* Removed until CA undstands the purpose
   for(i = 0; i < ns_model; i++)
        for ( t = 0; t <= span; t++)
                vp[i][t] = mvp[i][t];
   */


#if defined(MACRO_INCL)
    ObjPeriod = t - (short)gb.GetBaseYr()-1;
    ObjectiveValue =Tsptr[iobjective]->ts[ObjPeriod];
#endif
    return(ObjectiveValue);
    }// end funk

// coefread first reads the heart.dat file to get the estimated regression
// coefficients.  Then, if we are optimizing, it goes on to identify which
// pararmeters in which equations are to vary and to get the stepsizes.
bool coefread(void){
    char    vname[20], temp[20], card[750], dvname[40];
    short jgf; // for getfloat calls
    int  i, j, ii, jj, k, n, len;
    float  **a, *u;
    static struct {char first_pass;} flags = {1};
    FILE *fpmax;
    if (flags.first_pass) {
        flags.first_pass = 0;
        if ((fpdat = fopen("heart.dat", "rt")) == NULL) {
            fprintf(stderr, "Cannot open heart.dat\n");
            exit(3);
            }
        }

    /* rewind pointer in heart.dat */
    rewind(fpdat);
    depvarnames = new char*[nequ];

    i = 0;      /* coef[i][] */
    while (i < nequ){
        /* store dependent variable name */
        fscanf(fpdat, "%s", vname);
        j = strlen(vname);
        depvarnames[i] = new char[j+1];
        strcpy(depvarnames[i],vname);

        while (fgetc(fpdat) != '\n' );

        /* coeff = */
        fscanf(fpdat, "%s", temp);
        if (strcmp(temp, "coeff") != 0) {
            fprintf(stderr,"\nFound %s when I was expecting  Coeff\n",temp);
            fprintf(stderr,"before equation %d for %s (?) in heart.dat\n",
                i+1, vname);
            exit(4);
            }
        while (fgetc(fpdat) != '\n' );

        /* coef[][j] */
        j = 0;      // coef[][j]
        while (j < ncoef[i])
            fscanf(fpdat, "%f", &coef[i][j++]);
        if (i < nequ-1)
            while (fgetc(fpdat) != '\n' );

        /* ER: Although when maximizing we don't have stochastic capabilities we still
        need to read the coefficients of a stochasticly built model.*/

        if (stochastic_indicator[i] == 's') {
            /* rho */
            while (fgetc(fpdat) != '=' );
            fscanf(fpdat, "%f", &rho1[i]);
            while (fgetc(fpdat) != '\n' );

            /* see */
            while (fgetc(fpdat) != '=' );
            fscanf(fpdat, "%f", &see1[i]);
            while (fgetc(fpdat) != '\n' );

            /* pc matrix */
            if ((a = matrix(0, ncoef[i]-1, 0, ncoef[i]-1)) == NULL)
                exit(4);
            while (fgetc(fpdat) != '\n' );    /* pass pc_matrix = */
            k = 0;
            while (k < ncoef[i]*ncoef[i]){
                fscanf(fpdat, "%f", &a[k/ncoef[i]][k%ncoef[i]]);
                k++;
                }

            free_matrix(a, 0, ncoef[i]-1, 0);
            if (i < nequ-1)
                while (fgetc(fpdat) != '\n' );
            }

        i++;
        }  /* end reading of coefficients */

    if(MaxFlag == 'n') return YES;
    /* If maximizing, find coefs affected and step sizes.
    format of optspec.dat
        objective
        maxparam
        depvar1
          step1 step2 step3 etc
        depvar2
          step1 step2 step3 etc
    where
    objective is the name of the variable whose last value will be minimized;
    maxparam  is an upper bound on the number of parameters to be
               involved in the maximization.
    depvar1 is the name of a dependent variable and step1 is the
      step size for coef 1, step2 for coef 2, etc.  If stepN is 0, then
      coefN is not involved in the maximization.

    Each coef involved in the maximization must be recorded in the
    program by its equation number, coefficient number and step size.

    */

    if((fpmax = fopen(OptSpecFileName,"rt"))==0){
        printf("Cannot open %s\n",OptSpecFileName);
        return NO;
        }
    int parammax; // Maximum number of paramaters,
    int m;
    float ssize;
    // Read name of objective variable
    fgets(card,500,fpmax);
    i = 0;
    while(card[i]!= ' ' && card[i] != '\n'){
        objective[i] = card[i++];
        }
    objective[i] = '\0';

    // Read maximum number of parameters
    fgets(card,500,fpmax);
    sscanf(card,"%d",&parammax);
    // For each parameter which can be changed in the course of optimization,
    // we record the name of the dependent variable in which occurs,
    // the equation number (in the coef[][] array),
    // the parameter's position in the equation, and
    // the initial stepsize for the parameter
    eqname = new char*[parammax];
    eqnum =   new short[parammax];
    coefnum = new short[parammax];
    stepsize = new float[parammax];

    nparam = 0; // counts the number of parameters involved in optimization
    while(1){
        nextline:// provision for comment lines
        if(fgets(card,750,fpmax)== NULL) break;
        if(card[0] == '#') goto nextline;

        // Get the name of the dependent variable of an equation
        j = 0;
        while(card[j] != ' ' && card[j] != '\n')dvname[j] = card[j++];
        dvname[j] = '\0';
        j = 0; //ER: added this line to restart pointer after finding the variable name
        i = 0;
        // locate the dependent variable
        while(strcmp(dvname,depvarnames[i])!= 0 && i < nequ) i++;
        if(i == nequ) {
            printf("%s is not the name of a dependent variable.\n",dvname);
            return NO;
            }
        else{ // Found the dependent variable; it is number i. Record info.
            n = ncoef[i]; // number of coefficients in the equation
            m = 0; //counts parameters in this equation whether or not
                   // involved in the maximization.
            // get the line with the step sizes into card, with provision for comment lines.
            another:if(fgets(card,750,fpmax)== NULL) break;
            if(card[0] == '#') goto another;
            jgf = 0;
            // Read the stepsizes line
            while(m < n){
                if(getfloat(ssize, fpmax, card, jgf)== 1){
                    if(fabs(ssize) > 0){
                        stepsize[nparam] = ssize;
                        len = strlen(dvname);
                        eqname[nparam] = new char[len+1];
                        strcpy(eqname[nparam],dvname);
                        eqnum[nparam] = i;
                        coefnum[nparam] = m;
                        nparam++;
                        if(nparam >= parammax){
                            printf("You need a larger MaxParameters at top of MaxSpec.dat file.\n");
                            return NO;
                            }
                        }
                    m++;
                    }
                else break;
                }
            }
        }
    fclose(fpmax);
    return YES;
    } // end coefread

/*******************************************************************
amoeba -- Multidimensional minimization of the function funk(x) where
x[1..ndim] is a vector in ndim dimensions, by the downhill simplex
method of Nelder and Mead.  The matrix p[1..ndim+1] [1..ndim] is input.
Its ndim+1 rows are ndim-dimensional vectors which are the vertices of
the starting simplex.  Also input is the vector y[1..ndim+1], whose
components must be pre- initialized to the values of funk evaluated at
the ndim+1 vertices (rows) of p; and ftol the fractional convergence
tolerance to be achieved in the function value (n.b.!).  On output, p
and y will have been reset to ndim+1 new points all within ftol of a
minimum function value.

This routine is taken from Numerical Recipes in C. It uses a pointer
to the function to be minimized.  On the use of pointers to functions,
see Kernighan and Ritchie, Chp 5.12, pp 114-117 in the first edition.

*/

#define TINY 1.0e-10// A small number.
#define GET_PSUM \
    for (j=1;j<=ndim;j++) {\
    for (sum=0.0,i=1;i<=mpts;i++) sum += p[i][j];\
    psum[j]=sum;}
#define SWAP(a,b) {swap=(a);(a)=(b);(b)=swap;}
void amoeba(float **p, float y[], int ndim, float ftol, float (*funk)(float [])){
    float amotry(float **p, float y[], float psum[], int ndim,
        float (*funk)(float []), int ihi, float fac);
    int i,ihi,ilo,inhi,j,mpts=ndim+1;
    float rtol,sum,swap,ysave,ytry,*psum;
    char simplexstatus[14];
    float psave,yhi;
    int matherr,nyhi=0;
    bool firstround=0;
    psum=vector(1,ndim);
    GET_PSUM
    strcpy(simplexstatus,"Initial:     ");
    printf("\nStarting or restarting maximization");
    printf("\n                Best Point   Worst Point   Diff/Avg    Criterion\n");
    while(1) {
        ilo=1;
        /*First we must determine which point is the highest (worst),
        next-highest, and lowest(best), by looping over the points
        in the simplex.*/
        //ihi = y[1]>y[2] ? (inhi=2,1) : (inhi=1,2); translates to:
        if(y[1]>y[2]){
            inhi = 2;
            ihi = 1;
            }
        else{
            inhi =1;
            ihi = 2;
            }
        for (i=1;i<=mpts;i++) {
            if (y[i] <= y[ilo]) ilo=i;
            if (y[i] > y[ihi]) {
                inhi=ihi;
                ihi=i;
                }
            else if (y[i] > y[inhi] && i != ihi)
                inhi=i;
            }
        // ER: Check to see if the worst point has improved and count if it hasn't.
        if (firstround==0){
            yhi = y[ihi];
            firstround = 1;
            }
        if (y[ihi] >= yhi) nyhi += 1;
        else{
            yhi = y[ihi];
            nyhi = 0;
            }

        // Compute convergence test, the fractional range from highest to lowest,
        // and return if satisfactory.
        rtol=2.0*fabs(y[ihi]-y[ilo])/(fabs(y[ihi])+fabs(y[ilo])+TINY);
        // Print status
        gotoxy(1,wherey());
        cprintf("%12.10s %12.7f %12.7f %12.7f %12.7f\n",simplexstatus,y[ilo],y[ihi],rtol,ftol);
        fprintf(fpConvCheck,"%12.10s %12.7f %12.7f %12.7f %12.7f\n",simplexstatus,y[ilo],y[ihi],rtol,ftol);
        if (rtol < ftol) {// If returning, put best point and value in slot 1.
            SWAP(y[1],y[ilo])
            for (i=1;i<=ndim;i++) SWAP(p[1][i],p[ilo][i])
            break;
            }
        /* ER: If the worst point has not improved in a long time, restart the
        maximization (in case the maximization is not improving and there is still
        a considerable difference in the objective function.*/
        if (nyhi >= ndim * 10){
            SWAP(y[1],y[ilo])
            for (i=1;i<=ndim;i++) SWAP(p[1][i],p[ilo][i])
            break;
            }

        /*Begin a new iteration. First extrapolate by a factor of 1
        through the face of the simplex across from the high point,
        i.e., reflect the simplex from the high point.*/

        ytry=amotry(p,y,psum,ndim,funk,ihi,-1.0);
        strcpy(simplexstatus,"Reflect:     ");
        if (ytry <= y[ilo]){
            /*  Gives a result better than the best point,so try an additional
                extrapolation by a factor of 2. */

            ytry=amotry(p,y,psum,ndim,funk,ihi,2.0);
            strcpy(simplexstatus,"Expand:      ");}
        else if (ytry >= y[inhi]) {
            /*The reflected point is worse than the second-highest, so
            look for an intermediate lower point, i.e., do a
            one-dimensional contraction.*/
            ysave=y[ihi];
            ytry=amotry(p,y,psum,ndim,funk,ihi,0.5);
            strcpy(simplexstatus,"Contract:    ");
            if (ytry >= ysave) {
                /* Can't seem to get rid of that high point.  Better
                shrink around the lowest (best) point.*/


                for (i=1;i<=mpts;i++){
                    if (i != ilo) {
                        for (j=1;j<=ndim;j++){

            /* ER: matherr checks to see if the difference between points is so small
            that the computer can no longer make mathematical operations with them
            to 7 significant figures. When it detects this condition it sets the
            points equal to the best point (this causes the maximization to restart)*/

                            matherr = 0;
                            psave = p[i][j];
                            if(fabs(p[i][j]-0.5*(p[i][j]+p[ilo][j])) > 0.0) matherr = 1;
                            p[i][j]=psum[j]=0.5*(p[i][j]+p[ilo][j]);
                            if(matherr==1 && fabs(psave-p[i][j]) <= 0.0 ){
                                p[i][j]=psum[j]=p[ilo][j];
                                }
                            }
                        y[i]=(*funk)(psum);
                        }
                    else  { // This "else" added by CA to debug.  Remove
                        y[i]=(*funk)(psum);
                        y[i]=(*funk)(psum);
                        }
                    }
                //Recompute psum.
                GET_PSUM
                strcpy(simplexstatus,"Shrink:      ");
                }
            }
        } //Go back for the test of doneness and the next iteration.
    free_vector(psum,1);
    }
/**********************************************************************
amotry -- Extrapolates by a factor fac through the face of the
    simplex across from the high point, tries it, and replaces the high
    point if the new point is better.
***********************************************************************/

float amotry(float **p, float y[], float psum[], int ndim,
    float (*funk)(float []), int ihi, float fac){
    int j;
    float fac1,fac2,ytry,*ptry;

    ptry=vector(1,ndim);
    fac1=(1.0-fac)/ndim;
    fac2=fac1-fac;
    for (j=1;j<=ndim;j++){
        ptry[j]=0.0;
        ptry[j]=psum[j]*fac1-p[ihi][j]*fac2;
        }
    // Debug
    //for (j=1;j<=ndim;j++){
    //    printf(" %10.2f",ptry[j]);
    //    }
    //printf("\n");
    ytry=(*funk)(ptry); //Evaluate the function at the trial point.
    if (ytry < y[ihi]) {
        //If it's better than the highest, then replace the highest.
        y[ihi]=ytry;
        for (j=1;j<=ndim;j++) {
            psum[j] += ptry[j]-p[ihi][j];
            p[ihi][j]=ptry[j];
            }
        }
    free_vector(ptry,1);
    return ytry;
    }

// coefwrite creates the DAT file identical to heart.dat but
// with the optimized coefficients.  The name of the file is
// the root name of OptSpecFileName, followed by .dat.
bool coefwrite(void){
    int  i, j, t, k, ii, jj;
    char coeffile[35],vname[32],temp[80];
    float  **a;
    FILE *fp;
    FILE *dim;
    float dummy;

    for (i=0; OptSpecFileName[i] != '.' && OptSpecFileName[i] != NULL; i++)
        coeffile[i] = OptSpecFileName[i];
    if (i > 30) return NO;
    coeffile[i] = '.';
    coeffile[i+1] = 'd';
    coeffile[i+2] = 'a';
    coeffile[i+3] = 't';
    coeffile[i+4] = '\0';

    if((fp = fopen(coeffile,"wt")) == 0){
        printf("Could not open %s.\n",coeffile);
        return NO;
        }

    // The principal components matrix for each regression was not
    // stored.  The only way to get it back to to read heart.dat

    /* rewind pointer in heart.dat */
    rewind(fpdat);

    i = 0;                                          /* coef[i][] */
    while (i < nequ){
        /* dependent variable name */
        fscanf(fpdat, "%s", vname);
        while (fgetc(fpdat) != '\n' );

        /* coeff = */
        fscanf(fpdat, "%s", temp);
        if (strcmp(temp, "coeff") != 0) {
            fprintf(stderr,"\nFound %s when I was expecting  Coeff\n",temp);
            fprintf(stderr,"before equation %d for %s (?) in heart.dat\n",
                i+1, vname);
            exit(4);
            }
        while (fgetc(fpdat) != '\n' );

        /* coef[][j] */
        j = 0;                                      /* coef[][j] */
        while (j < ncoef[i]){
            fscanf(fpdat, "%f", &dummy);
            j++;
            }
        if (i < nequ-1)
            while (fgetc(fpdat) != '\n' );

        if (stochastic_indicator[i] == 's') {
            /* rho */
            while (fgetc(fpdat) != '=' );
            fscanf(fpdat, "%f", &rho1[i]);
            while (fgetc(fpdat) != '\n' );

            /* see */
            while (fgetc(fpdat) != '=' );
            fscanf(fpdat, "%f", &see1[i]);
            while (fgetc(fpdat) != '\n' );

            /* pc matrix */
            if ((a = matrix(0, ncoef[i]-1, 0, ncoef[i]-1)) == NULL)
                exit(4);
            while (fgetc(fpdat) != '\n' );    /* pass pc_matrix = */
            k = 0;
            while (k < ncoef[i]*ncoef[i]){
                fscanf(fpdat, "%f", &a[k/ncoef[i]][k%ncoef[i]]);
                k++;
                }
            }

        fprintf(fp,"%s\n", depvarnames[i]);
        fprintf(fp,"coeff =\n");
        t = 0;
        for (j=0; j < ncoef[i]; j++){
            if(t > 2){
                fprintf(fp,"\n");
                t = 0;
                }
             fprintf(fp,"%f  ",coef[i][j]);
            t++;
            }
        fprintf(fp,"\n");
        if(stochastic_indicator[i] == 's'){
            fprintf(fp,"rho = %6.3f\n",rho1[i]);
            fprintf(fp,"SEE = %12.6f\n",see1[i]);
            for(ii = 0; ii < ncoef[i]; ii++){
                for(jj = 0; jj < ncoef[i]; jj++)
                    fprintf(fp," %12.6f",a[ii][jj]);
                fprintf(fp,"\n");
                }
            }
        i++;
        }

    fclose(fp);

    printf("Coefficients for optimized model are in %s.\n",coeffile);

    return YES;
    }

