//
// MESSAGE.CPP -- Methods for GMessage class.

#include <stdio.h>  
#include <iostream.h>
#include <conio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <string.h>

#include "message.h"

// Here are some macros that make the use of this class easier.
//  They assume that the class object is MsgObject

// Comment out the following line to use this in another program
//#define TEST

#ifdef TEST

void main() {
GMessage MsgObject;

for(int i=0;i<50;i++)
   printf("msgbk %d: %s\n",i,MSGBK(i) );

}
#endif

/*==========================================================================*/
GMsg::GMsg() {
//cout << "Default GMsg constructor called. \n";
MsgText=0;
}

GMsg::GMsg(char *s) {
MsgText=new char[strlen(s)+1];
strcpy(MsgText,s);
}

GMsg& GMsg::operator = (char *s) {
if(MsgText) {
	delete[] MsgText;
	MsgText=0;
	}
MsgText=new char[strlen(s)+1];
strcpy(MsgText,s);
return *this;
}

GMsg::~GMsg() {
if(MsgText) {
	delete[] MsgText;
	MsgText=0;
	}
}

/*==========================================================================*/
// default constructor -- sets up the message definitions.  When adding
//    new messages, change the appropriate constant in the enum structure
//    in message.h

GMessage::GMessage() {

//cout << "Constructing GMessage. " << 
//	((Initialized)?"Already initialized. ":"Not initialized yet. ") << "\n";
RefCount++;
if(Initialized)
	return;

msgbk = new GMsg[MAXMSGBK];
msgbk[0] = "\r\nFormat is \r\nbank <filename>\r\n";
msgbk[1] = "\r\nCannot open %s\r\nNo bank now assigned\r\n";
msgbk[2] = "\r\n Cannot open index file %s\r\nNo bank now assigned\r\n";
msgbk[3] = "\r\nTitle of assigned bank:\r\n%s";
msgbk[4] = "\r\nBase year %d; first period covered %d";
msgbk[5] = "\r\nMax observations per series %d.  ";
msgbk[6] = "Contains %d series.\r\n";
msgbk[7] = "\r\nCannot position to write ";
msgbk[8] = "\r\nCannot write %s on %f";
msgbk[9] = "\r\nNo room for any more variables in data bank\r\n";
msgbk[10] = "\r\nSeries = %d; Characters in names = %d";
msgbk[11] = " \r\nCannot fseek.\r\n";
msgbk[12] = "\r\nCannot write index file.\r\n";
msgbk[13] = "\r\nIndex file not written \r\n";
msgbk[14] = "\r\nIndex file not written.\r\n";
msgbk[15] = "\r\nCannot fseek.\r\n";
msgbk[16] = "\r\nCannot read index file.\r\n";
msgbk[17] = "\r\nIndex file not read \r\n";
msgbk[18] = "\r\nIndex file not read.\r\n";
msgbk[19] = "\r\nIndex file read.\r\n";
msgbk[20] = "\r\nYou Need to provide a g.cfg file.  Thank you.\r\n";
msgbk[21] = "\r\nProvide build.cfg file\r\n";
msgbk[22] = "\r\nCannot open assigned bank index\r\n";
msgbk[23] = "\r\nCannot read assigned bank.\r\n";
msgbk[24] = "\r\nCannot open %s.\r\n";
msgbk[27] = "\r\nBad entry in config file \r\n";
msgbk[28] = "\r\nCannot seek on ws bank.\r\n";
msgbk[29] = "\r\nCannot write on ws .bnk file.\r\n";
msgbk[30] = "\r\nNo name on data command.";
msgbk[31] = "\r\nNo name on data command.";
msgbk[32] = "\r\nDate before beginning of workspace\r\n";
msgbk[33] = "\r\nJunk on data line";
msgbk[34] = "\r\nNo name on data command.";
msgbk[35] = "\r\nAll observations for a quarter must be on the same line.";
msgbk[36] = "\r\nError in date on data line.";
msgbk[37] = "\r\nJunk on data line";
msgbk[38] = "\r\nall observations for a quarter must be on the same line. ";
msgbk[39] = "Give series names:\r\n";
msgbk[40] = "\r\nNo more than 20 series allowed on matdat command.\r\n";
msgbk[41] = "\r\nObservation outside range of workspace bank. %s\r\n";
msgbk[42] = "\r\nBad format; see help menu\r\n";
msgbk[43] = "\r\nSupplied = sign";
msgbk[44] = " \r\n error in bup command; check parentheses";
msgbk[45] = "\r\nBad format\r\n";
msgbk[46] = "\r\nCannot find %s\r\n";
msgbk[47] = "\r\nBad format\r\n";
msgbk[48] = "\r\n%s has %d observations per year.";
msgbk[49] = "\r\nNew frequency (Return for no change):";
msgbk[50] = "\r\nNew title (Return for no change):";
msgbk[51] = "\r\nFormat is: btitle <a | w>";
msgbk[52] = "\r\nTitle:\r\n%s";
msgbk[53] = "\r\nBase year %d; first period covered %d.";
msgbk[54] = "\r\nMax observations per series %d.  ";
msgbk[55] = "Contains %d series.\r\n";
msgbk[56] = "\r\nFormat is \r\nwsbank <filename>\r\n";
msgbk[57] = "\r\nCannot open %s\r\nNo workspace assigned.\r\n";
msgbk[58] = "\r\n Cannot open index file %s\r\nNo workspace assigned.\r\n";
msgbk[59] = "\r\nTitle of workspace:\r\n%s";
msgbk[60] = "\r\nBase year %d; first period covered %d";
msgbk[61] = "\r\nMax observations per series %d.  ";
msgbk[62] = "Contains %d series.\n";
msgbk[63] = "Unrecognized bank type %s\n";
msgbk[64] = "Illegal bank number: %d\r\n";
msgbk[65] = "\r\nThis bank assigned as bank: %c.\r\n";
msgbk[66] = "\r\nBase year %d.";
msgbk[67] = "\r\nIllegal name: %s.\r\n";

msgg = new GMsg[MAXMSGG];
msgg[0] = "\r\nCore left %lu Core required %lu .";
msgg[1] = "\r\nThis machine has too little RAM to use the default sizes";
msgg[2] = "\r\nfor data banks.  You get the midget version.";
msgg[3] = "\r\nIt requires %lu.";
msgg[4] = "\r\nTap any key to continue.";
msgg[5] = "\r\nNot a G command.\r\n";
msgg[6] = "\r\n no name in add command.\r\n";
msgg[7] = "\r\n cannot open %s ";
msgg[8] = "Missing bracket. ";
msgg[9] = "Date must be a valid G date. \r\n";
msgg[10] = "Missing right brace. \r\n";
msgg[11] = "\r\nDate: %dyear %dmonth %dday";
msgg[12] = "  Time: %02d:%02d:%02d.%02d";
msgg[13] = "Lag must be an integer\r\n";
msgg[21] = "\r\n\r\n Please press:";
msgg[22] = "\r\n Enter To begin normally.";
msgg[23] = "\r\n a     To set range of the workspace.";
msgg[24] = "\r\n b     To recover the workspace of the previous run of G";
msgg[25] = "\r\n=>";
msgg[26] = "\r\n Last two digits of desired base year of workspace: ";
msgg[27] = "\r\nMaximum number of observations is %d";
msgg[28] = "\r\nNumber of observations per series:";
msgg[29] = "\r\nFirst month covered:";
msgg[30] = "\r\nType  help  for help; type  q  to quit.";
msgg[31] = "\r\nCould not read index.";
msgg[32] = "\r\nCould not read bank.";
msgg[33] = "\r\nFormat is: fadd <CommandFile> <ArgumentFile>\r\n";
msgg[34] = "\nArithmetic error in last operation. Do not trust result.\n";

msglsc = new GMsg[MAXMSGLSC];
msglsc[0] = "\r\nFormat is \r\n addprint <y | n>\r\n";
msglsc[1] = "\r\naddprint is %d\r\n";
msglsc[2] = " \r\n no left side variable ";
msglsc[3] = "\r\n No = in f command; one supplied.";
msglsc[4] = " \r\n error in f command; check parentheses";
msglsc[5] = "\r\n Letter of the bank must be between \'a\' and \'j\'.\r\n";
msglsc[7] = "\r\nThe format is \r\n listnames <ws | assigned | nbank> [wildcard]\r\nwhere the wildcard can be either '*' for any number of characters,\r\n or '^' for any single character.";
msglsc[8] = "Cannot open %s";
msglsc[11] = "=== more ====";
msglsc[12] = "Present limits are %s %s %s\r\n";
msglsc[13] = "\r\nNeed at least two dates in limits command\r\n";
msglsc[14] = "Usage:  mode [forecast | test]\r\n";
msglsc[15] = "Present mode is forecast\r\n";
msglsc[16] = "Present mode is test\r\n";
msglsc[17] = "\r === tap space bar for more; tap Esc to break ===";
msglsc[18] = "\r\n Can't open %s\r\n";
msglsc[20] = "\r\n First date is before beginning of workspace bank. \r\n";
msglsc[21] = "\r\n Need two dates. \r\n";
msglsc[22] = "\r\n Second date is too far out. \r\n";
msglsc[23] = "\r\n Give seriesnames on second line. \r\n";
msglsc[24] = "Give seriesnames >";
msglsc[26] = "\r\n No more than 20 names.\r\n";
msglsc[27] = "\r\n%s has wrong frequency.\r\n";
msglsc[28] = "\r\nNo name in type command. \r\n ";
msglsc[29] = "\r\n First date is before begining of workspace bank. \r\n ";
msglsc[30] = "\r\nDates do not match frequency of series.\r\n";
msglsc[31] = "\r\n second date too far out. \r\n";
msglsc[32] = "\r\nFormat is \r\n save <filename | off> \r\n";
msglsc[33] = "\r\nFormat is \r\n punch <filename | off> \r\n";
msglsc[34] = "\r\nBefore using pch, you must open file with punch command.\r\n";
msglsc[35] = "\r\nFormat is\r\n pch <name> <number>\r\n";
msglsc[36] = "\r\nThe format is \r\n cmtype <yes | no>";
msglsc[37] = "\r\nFollow ed with the name of the file to be edited.\r\n";
msglsc[38] = "\r\nError in vrange; see Help for plots.";
msglsc[39] = "Present print dates are %s %s\r\n";
msglsc[40] = "\r\nNeed two dates.\r\n";
msglsc[41] = "Present graph dates are %s %s %s\r\n";
msglsc[42] = "\r\nNeed at least two dates.\r\n";
msglsc[43] = "\r\nFormat is \r\n wri <y | n>\r\n";
msglsc[44] = "\r\nThe index of the work-space bank will be written whenever a variable is added.\r\n";
msglsc[45] = "\r\nCaution: the ws.ind file is NOT being written when a variable is added.\r\n";
msglsc[46] = "It will be written if you do \"q\" or \"wri y\".\r\n";
msglsc[47] = "Usage: vaxlab <in | out>";
msglsc[58] = "\r\nFormat is \r\n missing <y | n> [<Missing Text]>\r\n";
msglsc[59] = "\r\nmissing is %c  %s\r\n";
msglsc[60] = "\r\nFormat is \r\n catch <filename | off> \r\n";
msglsc[61] = "\r\nFormat is \r\n debug <filename | off> \r\n";
msglsc[62] = "Use: format {<width> [<decs>] [<obspl>]} | \"off\"\n\r";

msgrhs = new GMsg[MAXMSGRHS];
msgrhs[0] = "error: missing )";
msgrhs[1] = "\r\nUnrecognized element in expression\r\n";
msgrhs[2] = "\r\nBad syntax in expression.\r\n";
msgrhs[3] = "\r\nFrequency conflict in expression.\r\n";
msgrhs[5] = "@ must be followed by function name";
msgrhs[6] = " %s is not a recognized function";
msgrhs[7] = "syntax error in @cum(output,input,spill)";
msgrhs[8] = "syntax error in @peak(output,input,spill)";
msgrhs[9] = "\r\n error in %s function \r\n";
msgrhs[10] = "Indicator shorter than source.\n";
msgrhs[20] = "syntax error in conversion function";
msgrhs[21] = "\r\nError in inint.\r\n";
msgrhs[22] = "syntax error in interpolation function";
msgrhs[23] = "\r\nCannot open %s\r\n";
msgrhs[24] = "\r\nError in @interp function.\r\n";
msgrhs[25] = ":\t\t\t\t\tTap any key to continue.";

msgutil = new GMsg[MAXMSGUTIL];
msgutil[0] = "\r\nEnd of File on input.\r\n";
msgutil[1] = "Not enough space for %s, %d to %d.\n";
msgutil[2] = "Not enough space for %s, %d,%d,%d,%d.\n";
msgutil[3] = "Unable to allocate memory for row %d in %s.\n\r";

msgbpl = new GMsg[MAXMSGBPL];
msgbpl[0] = "\nFormat is  tcolor b f";
msgbpl[1] ="\nwhere b and f are the numbers of the background and foreground colors.";
msgbpl[2] =" Graphics System Error: %s\n";
msgbpl[3] ="\n Too many series";
msgbpl[4] ="\n first date is before beginning of workspace bank. \n ";
msgbpl[5] ="\n second date too far out. \n";
msgbpl[6] ="\n third date too far out. \n";
msgbpl[7] ="\n Unrecognized element";
msgbpl[8] ="\nCannot take logarithm of vertical range\n";
msgbpl[9] ="Tap f to flip back to graph, any other key to proceed.";
msgbpl[10] ="\nGraphdriver %d not supported.";
msgbpl[11] ="\nTap any key to proceed without graphics.";
msgbpl[12] ="\nGraphdriver %d mode %d not supported.";
msgbpl[13] ="\nTap any key to proceed without graphics.";
msgbpl[14] ="\nPresent driver and mode are %d %d.";
msgbpl[15] ="\nGive new drive and mode:";
msgbpl[16] = "\nThose values failed.";
msgbpl[17] = "\nSeries must all have same frequency.";
msgbpl[18] = "\nFrequency of series does not match dates. Use gdates command.";

msgrc = new GMsg[MAXMSGRC];
msgrc[0] = "\r\nNot enough memory";
msgrc[1] = "An = sign is expected in an r command.\r\n";
msgrc[2] = "Too much data\r\n";
msgrc[3] = "\r\nCalculating ...";
msgrc[4] = "\r\nStdDev and Cross Correlation Matrix";
msgrc[5] = "\r\nStrike any key to continue";
msgrc[6] = "Error: Variable %d is a combination of preceeding variables\r\n";
msgrc[7] = "\r\nTap: b beta, f F's, d derivatives, e Elas, m Mexvals, r NorRes, Enter = go on";
msgrc[8] = "With respect to which coefficient:";
msgrc[9] = "\rHesitating ... tap any key to see results.";
msgrc[10] = "Regression number %d, %-20s";
msgrc[11] = "\r\n  SEE   = %10.2f RSQ   = %6.4f RHO = %6.2f Obser  = %4d from %8.3f";
msgrc[12] = "\r\n  SEE+1 = %10.2f RBSQ  = %6.4f";
msgrc[13] = " DoFree = %4d to   %8.3f";
msgrc[14] = "\r\n  MAPE  = %10.2f";
msgrc[15] = " SEESUR = %10.2f";
msgrc[16] = " Test period:   SEE %8.2f MAPE   %6.2f end  %8.3f";
msgrc[17] = "\r\n    Variable name           Reg-Coef  Mexval t-value";
msgrc[18] = "  Elas   NorRes     Mean";
msgrc[19] = "\r\n  Perfect fit. Mexvals and T-stats meaningless.";
msgrc[20] = "%5d is too many constraints.\r\n";
msgrc[21] = "Need positive number for trade-off parameter.\r\n";
msgrc[22] = "Number is needed for constraint.\r\n";
msgrc[23] = "Syntax requires = sign.\r\n";
msgrc[24] = "Bad format in con command.\r\n";
msgrc[25] = "Need number for trade-off parameter. \r\n";
msgrc[26] = "Need an 'a' for a_first. \r\n";
msgrc[27] = "Need an 'a' for a_last. \r\n";
msgrc[28] = "Need order of polynomial.)\r\n";
msgrc[29] = "\r\nFormat is\r\nhesitate <y|n>\r\n";
msgrc[30] = "Not enough memory.\r\n";
msgrc[31] = " JarqBer = %4.2f";

Initialized=1;
}
// ============================================================================
GMessage::~GMessage() {

// Only delete these messages when we are down to the last Message Object.
RefCount--;
if(!RefCount) {
//	printf("Executing GMessage Destructor...\n");
	if(msgbk) {
   	delete[] msgbk;
   	msgbk=0;
   	}
	if(msgg) {
   	delete[] msgg;
		msgg=0;
		}
	if(msglsc) {
   	delete[] msglsc;
   	msglsc=0;
   	}
	if(msgrhs) {
   	delete[] msgrhs;
   	msgrhs=0;
   	}
	if(msgutil) {
   	delete[] msgutil;
   	msgutil=0;
   	}
	if(msgbpl) {
   	delete[] msgbpl;
   	msgbpl=0;
   	}
	if(msgrc) {
   	delete[] msgrc;
   	msgbpl=0;
   	}
	Initialized = 0;
	}
}
/*==========================================================================*/
char* GMessage::GetGMessage(char* type,int index) {

if(strcmp(type,"msgbk")==0)
	return(msgbk[index].MsgText);
else if(strcmp(type,"msgg")==0)
	return(msgg[index].MsgText);
else if(strcmp(type,"msglsc")==0)
	return(msglsc[index].MsgText);
else if(strcmp(type,"msgrhs")==0)
	return(msgrhs[index].MsgText);
else if(strcmp(type,"msgutil")==0)
	return(msgutil[index].MsgText);
else if(strcmp(type,"msgbpl")==0)
	return(msgbpl[index].MsgText);
else if(strcmp(type,"msgrc")==0)
	return(msgrc[index].MsgText);
return 0;
}
/*==========================================================================*/
