// MESSAGE.H
// A general class for storing and retrieving global messages.
// (Shouldn't this make use of the String class?)
// 

#if !defined(MESSAGE_H)
#define MESSAGE_H 1


// Macros for printing the different families of messages:
#define MSGBK(n)  MsgObject->GetGMessage("msgbk",n)
#define MSGG(n)   MsgObject->GetGMessage("msgg",n)
#define MSGLSC(n) MsgObject->GetGMessage("msglsc",n)
#define MSGRHS(n) MsgObject->GetGMessage("msgrhs",n)
#define MSGMISC(n) MsgObject->GetGMessage("msgmisc",n)
#define MSGBPL(n) MsgObject->GetGMessage("msgbpl",n)
#define MSGUTIL(n) MsgObject->GetGMessage("msgutil",n)
#define MSGRC(n)   MsgObject->GetGMessage("msgrc",n)

class GMsg {
  protected:
  public:
	char *MsgText;
	GMsg();
	GMsg(char *s);
	GMsg& operator = (char*);
	~GMsg();
};

class GMessage {
  protected:
	enum {MAXMSGBK=70, MAXMSGG=45, MAXMSGLSC=80,MAXMSGUTIL=10,
		MAXMSGRHS=40, MAXMSGBPL=35, MAXMSGRC=35};
	// Messages are static (only one occurrence for objects of type
	//   Message.)
	static GMsg *msgbk,*msgg,*msglsc,*msgrhs,*msgutil,
      *msgmisc,*msgbpl,*msgrc;
	static int Initialized;  // prevents from allocating Msg's more than
										// once.
   static int RefCount;     // How many objects are working?  (Only
		// delete arrays after destructing the last one!
  public:
	GMessage();
	~GMessage();
	char *GetGMessage(char*,int);
};

#endif  // end MESSAGE_H definitions

