/* PADS.H
    This class stores data for the Perhaps Adequate Demand System, PADS.

#if (!defined(PADS_H))
#define PADS_H 1
*/
#include "equation.h"
class Vector;
class Matrix;

struct Pads   : public Equation
{
  public:
    short ng; //number of groups
    short nsg; // number of subgroups
    Vector lambda, share, mu, nu;
    short *group, *subgroup, *popnr, *cstarnr, *trendnr, *insystem;
    Pads();
    void r(char *filename);
    Pads(char *filename);
    ~Pads();
   // Version of equation with income, total pop and prices only:
    void padsf(Vector& pce, Vector& prices, Vector& tempi,
         Tseries& pop, Tseries& pcetotR);
   // Version of equation with weighted populations (popul), and
   //    cstar variables.  Total pce used for spreading only!
    void padsf(Vector& pce, Vector& prices, Vector& popul, Matrix& Cstar,
         Vector& tempi, Tseries& pcetotR);
    // No pce total to spread
    void padsf(Vector& pce, Vector& prices, Vector& popul, Matrix& Cstar,
         Vector& tempi);
    };
// #endif
